 
#include <Pilot.h>
#include <Graffiti.h>
#include <FloatMgr.h>
#include "MoneyRsc.h"




typedef struct 
	{
   UInt	renamedCategories;
	Char	categoryLabels[dmRecNumCategories][dmCategoryLength];
	Byte	categoryUniqIDs[dmRecNumCategories];
	Byte	lastUniqID;
	Byte	reserved1;
	Word	reserved2;
	Char	typeLabels[20][10]; // The above stuff is all standard. The type and tran labels are
	Char	tranLabels[20][20]; // for the popup lists in the Transaction Edit screen
	} MoneyAppInfoType;

typedef MoneyAppInfoType * MoneyAppInfoPtr; // This will contain a pointer to our data
typedef CharPtr MoneyDBRecordTypePtr;

typedef struct 
	{
	Byte				displayPref;			// Display Prefs - Used for check# display etc
	UInt				repeatBound;			// How far in advance we repeat transactions
	UInt				currentCategory;		// What category are we looking at
	UInt				topVisibleRecord;		// Which is the first record on the page
	UInt				currentRecord;			// Which record were we last looking at?
	ULong				currentRecordID;		// The ID of that recod in case the hotsync changes things and we need to look for it
	Byte				amountwidth,prefflags; // Width of the amount column and some flags
	Byte				mainstatuschoise;		// On the main display do we show Current, Min, Max balance?
	Char				dollarSign;				// What character do we want to use for the amounts?
	Char				version;					// What version of the database are we on?
	} MoneyPreferenceType;

typedef struct 
	{
	Char				flags;					// Has it cleared? Do we have a receipt?
	UInt				checknum;				// Check number or 0
	Long				amount,total;			// The "dollar" value of the amount and the running total after this transaction clears
	Int				amountc,totalc;		// The cents values as above
	DateTimeType	date;						// Transaction date
	Char				repeat;					// Type of repeat or 0 if it doesnt repeat
	Char				flags2;					// More flags
	Char				type;						// Which of the "type" list items this belongs to
	Char				reserved[3];			// For expansion
	Char				description[19];		// The actual description of the transaction
	Char				note[401];				// '0' terminated notes field.
	} TransactionType;

typedef TransactionType * TransactionTypePtr;








#define MoneyAppType		'Mony'
#define MoneyDBType		'MoDT'
#define MoneyDBName		"MoneyDB"
#define MoneyVersionNum	5
#define noRecordSelected	-1
#define noRecordSelectedID	-1
#define memosInCategoryUnknown	0xffff

#define updateCategoryChanged			0x01
#define titleReplacementChar		'#'
#define digitsForRecordPosition	6




static Long  			todaysTotal,todaysTotalc; 			// Used to display the total/balance at the bottom of the main screen
static DmOpenRef		MoneyDB;									// The database handle we'll use
static Char				CategoryName [dmCategoryLength],DollarSign='$';		// Default currency and category names
static Word				RecordCategory;						// Category of the currently displayed record
static Word 			NewCategory;
static Boolean			NewCategoryEdited,JumpNote;		// Jumpnote means the user cicked on the note and we need to open the edit screen, then the note screen
static Byte				MainStatusChoise=0,PrefFlags=0;	// Statuschoise is the choice of what gets displayed, balance, ending balance etc
static Boolean			NegativeValue;							// Used for calculations We are doing our own math as the FP math ont he pilot is SLLLOW
static CharPtr			EditViewTitlePtr = 0;				// Pointers to the titles of the screens
static CharPtr			MainViewTitlePtr = 0;
static Word				MemosInCategory;						// # Transactions in the current category
static Boolean 		DeleteIt=false;						// Set to true of we want to remove the current record
static Long				c1,c2;									// These are for our math functions as temp stores
static Byte				TotalWidth=0,AmountWidth=53;		// Widths of the columns to optimize space
static TransactionType WorkingTransaction,OldTransaction;  // Transaction we are editing, and the initial value of that transaction
static Boolean			Recalculate=false,Resort=false;	// Flags. WHen true well recalculate totals and sort the database respectively
static Int				CurrentView;							// What view are we looking at
static UInt				CurrentRecord = noRecordSelected;// Currently edited record
static Int				CurrentCategory = 0;					// Current category...
static Int				TopVisibleRecord = 0;				// First record on the main list screen
static UInt				RepeatBound=90;						// How far in advance we enter items
static Byte				DisplayPref=72;						// Displa preferences
static Char				mainTitle[15];							// The main view title scring
static Long				CurrentTotal,CurrentTotalc;		// Current totals. This is for calculating various balances etc
static CharPtr 		TypeChoices[20],DescChoices[20]; // Pointers to the popup list text in the edit screen
static Boolean			WhichList;								// When we go to edit a list, which one are we editing?
static Char				EditLabel[]="Edit List...";		// Label for the screen
	static CharPtr 		ListItemPointers[25];			// Pointer to the actual stuff we'll edit on the list edit screen
	static Char ListItems[20][30];							// And the items themselves





static void SetTypeList();
static void DoStatLine(Boolean Clear);
static void GetType(CharPtr string, Int i);
static void GetTran(CharPtr string, Int i);
static Int GetAmountWidth(Long amount, Int cents);
static Boolean StartApplication(void);
static void Recur(Boolean DisplayNotice);
static Int DupeIt(Word repeatType, Int recnum, UInt category);
static void StopApplication(void);
static VoidPtr GetObjectPtr(Int objectID);
static FieldPtr GetFocusObjectPtr(void);
static Boolean CreateRecord(Boolean Duplicate);
static void EditViewDoMenuCommand(Int command);
static Boolean EditViewDeleteCurrentRecord(void);
static void EditViewSaveData(void);
static void EditViewRetrieveData(void);
static Boolean EditViewHandleEvent(EventPtr event);
static void MainViewDrawRecordInBounds(TransactionType * Transaction,	RectanglePtr bounds, Boolean Searching);
	static void MainViewInit(void);
static Boolean MainViewHandleEvent(EventPtr event);
static Boolean ApplicationHandleEvent(EventPtr event);
static void EventLoop(void);
static Boolean SelectDate (void);
static Boolean EditViewUpdateDisplay (Int updateCode);
static void MyStrIToA(Char *string, Long i);
static Long MyStrAToI(Char *string);
static Long MyStrAToI2(Char *string);
static Int DateTypeCmp(DateTimeType d1, DateTimeType d2, Boolean FullCompare);
static Int MoneyCompareRecords(TransactionTypePtr r1, 
	TransactionTypePtr r2);


static Int DrawDot(Int x,Int y)		// Draws the status display bar at the top when Money launches
{
	static RectangleType rect;
	
rect.topLeft.x=x;
rect.topLeft.y=y;
rect.extent.x=15;
rect.extent.y=5;
WinDrawRectangle(&rect,0);
x=x+15;
return(x);
}

static void BusyNotice(Char *text)		// Draws the little busy box on the screen with a description in it
{
	RectangleType rect;
Char dummy[30];
Int offset;

if((PrefFlags & 4)!=4){
StrCopy(dummy,text);
offset=(FntCharsWidth(dummy,StrLen(dummy))/2);
offset=80-offset;
rect.topLeft.x=20;
rect.topLeft.y=66;
rect.extent.x=120;
rect.extent.y=30;

		WinDrawRectangle(&rect,2);
rect.topLeft.x=21;
rect.topLeft.y=67;
rect.extent.x=118;
rect.extent.y=28;

		WinEraseRectangle(&rect,2);
		FntSetFont (stdFont);
	
WinDrawChars(dummy,StrLen(dummy),offset,68);
}
}

static void BusyNoticePerc(Int done,Int total,Int BigBar)   // Draws the busy box "fuel guage"
																				// Done = how much is done total= total possible to be done
{
RectangleType rect;
Int diff;


if((PrefFlags & 4)!=4){total++;
done++;
if(BigBar){
			diff=110*done/total;
			rect.topLeft.x=24;
			rect.topLeft.y=84;
			rect.extent.x=diff;
			rect.extent.y=8;
			WinDrawRectangle(&rect,0);
}
else
{			diff=160*done/total;
			rect.topLeft.x=0;
			rect.topLeft.y=31;
			rect.extent.x=diff;
			rect.extent.y=3;
			WinDrawRectangle(&rect,0);
		}
	}
}




static TransactionType PtrToStruct(TransactionTypePtr	ptr)	// Copy a transaction fro a pointer to a structure
{
TransactionType	CurrentTransaction;
CurrentTransaction=*ptr;
return(CurrentTransaction);
}


static void Add(Long a1, Long a2, Long b1, Long b2)  // Our very own faser-than-fp add routine
{
Boolean anegative=false , bnegative=false, abigger=false;

if (a1<0)anegative=true; else
if (a1==0)if (a2<0)anegative=true;
if (b1<0)bnegative=true; else
if (b1==0)if (b2<0)bnegative=true;

	if(anegative){
			a1=a1*-1;a2=a2*-1;}
	if(bnegative){
			b1=b1*-1;
			b2=b2*-1;
			}
		

if(anegative==bnegative){
		// Same sign, just ad them!
		a1=a1+b1;
		a2=a2+b2;
		if (a2>99){
				a2=a2-100;
				a1++;
				}
		if(anegative==true){
				a1=a1*-1;
				a2=a2*-1;
				}
		c1=a1;
		c2=a2;
		return;
		};

if(anegative!=bnegative){
			
if(a1>b1)abigger=true;
if(a1==b1)if(a2>b2)abigger=true;
		
		
		if(abigger==true){
					c1=a1-b1;
					c2=a2-b2;
					if(c2<0){
							c2=c2+100;
							c1=c1-1;
							}
							}	
				else
				{
					c1=b1-a1;
					c2=b2-a2;
					if(c2<0){
							c2=c2+100;
							c1=c1-1;
							}
							}						
				if(abigger==true)if(anegative==true){
							c1=c1*-1;
							c2=c2*-1;}
				if(abigger==false)if(bnegative==true){
							c1=c1*-1;
							c2=c2*-1;
							}
				
				
		}
		
}



static void DrawHornet(void)				// Draws the hornet bitmap on the screen
{
static Handle					ObjectBitmapHandle;
static BitmapPtr				ObjectBitmapPtr;

ObjectBitmapHandle= DmGetResource( bitmapRsc, 1110);
ObjectBitmapPtr = MemHandleLock(ObjectBitmapHandle);

WinDrawBitmap(ObjectBitmapPtr,30,30);

MemPtrUnlock(ObjectBitmapPtr);
DmReleaseResource(ObjectBitmapHandle);
	
}

static void MyStrIToA(Char *string, Long i)		// Convert an long to string
{
	Char temp[40],temp2[40];
	Word negative = 0;
	
	if (i<0){
			negative=1;
			i=i*-1;
			}
	StrIToA(temp,i);
	if (negative==1){
		StrCopy(temp2,"-\0");
		StrCat(temp2,temp);
		StrCopy(temp,temp2);
		}
	StrCopy(string,temp);
}

static Long MyStrAToI(Char *string)			// Convert the non-decimal part of a string to a Long
{
	Char temp[40];
	Word negative = 0;
	Long i=0,j;
	for(i=0;i<39;i++)temp[i]='\0';
	StrCopy(temp,string);
	if(StrLen(temp)<=0)
	return(0);
	for(j=0;j<39;j++)if(temp[j]=='.')for(i=j;i<39;i++)temp[i]='\0';  // Look for and remove the "." and al after it. We dont want the cents
	for(j=0;j<39;j++)if((temp[j]<'0') | (temp[j]>'9') && (temp[j]!='-'))for(i=j;i<39;i++)temp[i]=temp[i+1];
	
	if(temp[0]=='-'){
			negative=1;
			for(i=0;i<39;i++)temp[i]=temp[i+1];
			}
	if(StrLen(temp)<=0)return(0);
			i=FplFloatToLong(FplAToF(temp));
			if(i>32767)if(i<65536)i--;  // Fix for USR's bug in FR
			if (negative==1)i=i*-1;
		
return(i);
}

static Long MyStrAToI2(Char *string)		// Convert the "cents" portion of a string to Long
{
	Char temp[40];
	Word negative = 0;
	Long i=0,j;
	Int found=-1;
	for(j=0;j<39;j++)temp[j]='\0';
	StrCopy(temp,string);
	if(StrLen(temp)<=0)
	return(0);
	for(j=0;j<39;j++)if(temp[j]=='-')negative=1;
	for(j=0;j<39;j++)if(temp[j]=='.')found=j;
	if (found>-1){
		for(j=found;j<39;j++)temp[j-found]=temp[j+1];
		for(j=0;j<39;j++)if((temp[j]<'0') | (temp[j]>'9') && (temp[j]!='-'))for(i=j;i<39;i++)temp[i]=temp[i+1];
		for(j=2;j<39;j++)temp[j]='\0';
		if(StrLen(temp)<2)StrCat(temp,"0");
	if(StrLen(temp)<=0)return(0);
			i=StrAToI(temp);
			if (negative==1)i=i*-1;

return(i);
} else return(0);
}


static void ConvertAmount(Char *string, Long dollar, Long cents, Boolean Dollars, Boolean ForEdit)
{
Int j;
Char temp[20],temp2[20],temp3[3];
Byte	UnitsPref,TensPref;


	TensPref=DisplayPref & 240;
	UnitsPref=DisplayPref & 7;
	StrCopy(temp3,"\0");
	if(Dollars==true){
			if (TensPref & 16){temp3[0]=DollarSign;temp3[1]='\0';}
			if (TensPref & 32){temp3[0]=DollarSign;temp3[1]='\0';}
			if (((dollar<0) | (cents<0)) & (Dollars==true))StrCat(temp3,"-\0");
	
			}
					MyStrIToA(temp,dollar);
					MyStrIToA(temp2,cents);
					if(temp2[0]=='-')for(j=0;j<5;j++)temp2[j]=temp2[j+1];
					if(temp[0]=='-')for(j=0;j<20;j++)temp[j]=temp[j+1];
					if(StrLen(temp2)==1){
					temp2[2]='\0';
					temp2[1]=temp2[0];
					temp2[0]='0';
					}
	
					if(ForEdit | ((TensPref & 32)==32) | ((TensPref & 64)==64)){
						StrCat(temp,".");
						StrCat(temp,temp2);
						}
					StrCat(temp3,temp);
					StrCopy(string,temp3);
}



// This writes the currenttransaction to the file at the current position.
// it saves the record "compressed" ie - without the entire padded note field.
static void CompressedWrite(UInt *RecordNum,TransactionType	CurrentTransaction)
{
VoidHand oldH;  // Old handle
VoidHand dstH; 
TransactionTypePtr dst;
Err error;
Boolean WasError=false; // We'll set this flag as True if any error occurs so that we can put up an alert
// Create a new handle of the right size
dstH = DmNewHandle(MoneyDB, (ULong) sizeof(TransactionType)-400+StrLen(CurrentTransaction.note));
if(dstH){
		dst = MemHandleLock (dstH);
		if(dst)DmWrite(dst, 0, &CurrentTransaction, sizeof(TransactionType)-400+StrLen(CurrentTransaction.note));
		else WasError=true;
		// Now use that handle for our record - ie put into the database
		if(dst){
				MemPtrUnlock(dst);
				error=DmAttachRecord (MoneyDB, RecordNum, dstH, &oldH);
				}
		if(error){
				WasError=true;
				if(dstH)MemHandleFree(dstH);
				}
		if(oldH)MemHandleFree(oldH);
		} else WasError=true;
if(WasError)FrmAlert(1097); // Some error occurred
}

static void GetType(Char * text, Int i) // Copy the type label # i in the prefs to a string
{
	MoneyAppInfoPtr	appInfoP;
	LocalID	dbID;
	LocalID appInfoID;
	UInt		cardNo;

			DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
			DmDatabaseInfo(0, dbID, NULL, NULL, NULL, NULL, NULL, NULL, 
			NULL, &appInfoID, NULL, NULL, NULL);
			appInfoP = MemLocalIDToLockedPtr(appInfoID, cardNo);
			if(appInfoP){
				StrCopy(text,appInfoP->typeLabels[i]);
				MemPtrUnlock(appInfoP);
				} else FrmAlert(1097); // Some error occurred
	
 }
 

static Int Scan(Int Function,Boolean Display, DateTimeType gotoDate, UInt refNum)
{
/* This function will scan through all the transactions in th database and do a specific task such as calculate
   totals, etc... 
   
   Functions:			1... Check database integrity
   						2... Find first record in this category
   						3... Calculate totals for each transaction
   						4... Find the first transaction on the date gotoDate
   						5... Old Quicken Export functions
   
   
   */
   
	UInt RecordNum;		// Which record number were on
	ULong MaxRecords;		// Total number of recs to parse
	UInt cardNo,theRecord=0;
	UInt RecCatagory,attr;
	LocalID dbID;
	VoidHand	recHandle;
	TransactionTypePtr	ptr;
	TransactionType	CurrentTransaction;
	Byte TempWidth;
	DateTimeType currentDate;
	Boolean hasChanged,WriteIt;


	// Initially, depending on the function to perform well need to do some setup.
		switch (Function)
			{
				case 3:
					if(Recalculate==false)return(-1);	// If we dont need to recalculate, exit now
					TimSecondsToDateTime (TimGetSeconds (), &currentDate);
					FntSetFont (stdFont);
					CurrentTotal=0;todaysTotal=0;todaysTotalc=0;
					CurrentTotalc=0;
	
				break;
				}

	
	DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL); // Get database info
	DmDatabaseSize(cardNo,dbID,&MaxRecords,NULL,NULL);					// See how many records we have to parse
	if(MaxRecords>0){																// only parse if we ave more than 0 records
	
	MaxRecords=MaxRecords-1;
	
	switch (Function)
			{
				case 1:
					BusyNotice("Checking Database\0");
				break;
				case 3:
					if(MainStatusChoise==2){todaysTotal=999999999;todaysTotalc=99;}
					if(MainStatusChoise==3){todaysTotal=-999999999;todaysTotalc=-99;}
					if(Display==true)BusyNotice("Calculating Totals\0");
					AmountWidth=0;
					TotalWidth=0;
					NegativeValue=false;
				break;
				}
	
	for(RecordNum=0;RecordNum<=MaxRecords;RecordNum++){
		if (Display)BusyNoticePerc(RecordNum,MaxRecords,true);
		recHandle = DmGetRecord(MoneyDB, RecordNum);
		if(recHandle)
			{
				DmRecordInfo (MoneyDB, RecordNum, &attr, NULL, NULL);
				RecCatagory = attr & dmRecAttrCategoryMask;
				ptr=MemHandleLock(recHandle);
				CurrentTransaction=PtrToStruct(ptr);
				
				switch (Function)
					{
						case 1:
							WriteIt=true;
						break;
						case 2:
							if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories)){
								MemHandleUnlock(recHandle);
								DmReleaseRecord(MoneyDB, RecordNum, false);
								return(RecordNum);
								}
						break;
						case 3:
							if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories)){
									Add(CurrentTotal,CurrentTotalc,CurrentTransaction.amount,CurrentTransaction.amountc);
									CurrentTotal=c1;CurrentTotalc=c2;
									hasChanged=false;
									if(CurrentTransaction.total!=CurrentTotal)hasChanged=true;
									if(CurrentTransaction.totalc!=CurrentTotalc)hasChanged=true;
									if(hasChanged){	CurrentTransaction.total=CurrentTotal;
												CurrentTransaction.totalc=CurrentTotalc;}
									switch(MainStatusChoise)
											{
												case 0:
													if (DateTypeCmp(CurrentTransaction.date,currentDate,true)<=0){
														todaysTotal=CurrentTotal;todaysTotalc=CurrentTotalc;}
												break;
												case 1:
													todaysTotal=CurrentTotal;todaysTotalc=CurrentTotalc;
												break;
												case 2:
													if(CurrentTotal<todaysTotal){
														todaysTotal=CurrentTotal;todaysTotalc=CurrentTotalc;}
													else if(CurrentTotal==todaysTotal)if(CurrentTotalc<todaysTotalc){
														todaysTotal=CurrentTotal;todaysTotalc=CurrentTotalc;}
												break;
												case 3:
													if(CurrentTotal>todaysTotal){
															todaysTotal=CurrentTotal;todaysTotalc=CurrentTotalc;}
													else if(CurrentTotal==todaysTotal)if(CurrentTotalc>todaysTotalc){
														todaysTotal=CurrentTotal;todaysTotalc=CurrentTotalc;}
												break;
												}
									if((CurrentTransaction.total<0) | (CurrentTransaction.totalc<0))NegativeValue=true;
									if((PrefFlags & 2)==0){
												TempWidth=GetAmountWidth(CurrentTransaction.total,CurrentTransaction.totalc);
												if (TempWidth>TotalWidth)TotalWidth=TempWidth;
												}
									TempWidth=GetAmountWidth(CurrentTransaction.amount,CurrentTransaction.amountc);
									if (TempWidth>AmountWidth)AmountWidth=TempWidth;
									if(hasChanged)WriteIt=true;
									}
									break;
									case 4:
										if (DateTypeCmp(CurrentTransaction.date,gotoDate,true)<=0){
																						//oldRec=theRecord;
																						theRecord=RecordNum;
																						}
									break;
									case 5:
									/*
									
									
*/
									break;
				}			
				MemHandleUnlock(recHandle);
				if(WriteIt)CompressedWrite(&RecordNum,CurrentTransaction);
								
				DmReleaseRecord(MoneyDB, RecordNum, WriteIt);
			
			}
		}	
			
		switch (Function)
					{
						case 3:
							AmountWidth+=5; // We need some extra space
							TotalWidth+=5;
							if(Display==true)DoStatLine(false);
						break;
					}
	
		} else
		{
		 switch (Function)
					{
						case 3:
							DoStatLine(true);
						break;
						}
		 }
		 
switch (Function)
		{
		case 3:
			if(Display==true){
				if(NegativeValue==true)StrCopy(mainTitle,"PilotMoney (-)\0"); else StrCopy(mainTitle,"PilotMoney (+)\0");
				MainViewTitlePtr=&mainTitle[0];
				FrmSetTitle(FrmGetActiveForm(),MainViewTitlePtr);
				}
			Recalculate=false;
		break;
		case 4:
			return(theRecord);
		break;
		}
		 
return(-1);
}





static void SortIt() // This puts up a notice and then uses th builtin Sort function
{
if(Resort==true){
BusyNotice("Sorting Transactions");
DmInsertionSort(MoneyDB,(DmComparF *) &MoneyCompareRecords,0);}
Resort=false;
}



static void DrawNote(void) // Draw the little note to mark a transaction as having or not having
// 									an attached note
{
static Handle					ObjectBitmapHandle;
static BitmapPtr				ObjectBitmapPtr;

if(StrLen(WorkingTransaction.note)>0)
ObjectBitmapHandle= DmGetResource( bitmapRsc, 1605);
else
ObjectBitmapHandle= DmGetResource( bitmapRsc, 1606);

ObjectBitmapPtr = MemHandleLock(ObjectBitmapHandle);

WinDrawBitmap(ObjectBitmapPtr,140,140);

MemPtrUnlock(ObjectBitmapPtr);
DmReleaseResource(ObjectBitmapHandle);
	
}



static void ClearScreen(void)
{
	RectangleType rect;
		rect.topLeft.x=0;
		rect.topLeft.y=0;
		rect.extent.x=160;
		rect.extent.y=140;
			WinEraseRectangle(&rect,0);
}

static Err	MoneyInitAppInfo(DmOpenRef dbP)
{
	UInt cardNo;
	VoidHand h;
	LocalID dbID;
	LocalID appInfoID;

	MoneyAppInfoPtr	appInfoP;

   MoneyAppInfoType DefaultMoneyAppInfo = 
	{
 
 	0x0006,

	"Unfiled",
	"Checking",
	"Savings",
	"Credit Card",
	"",	"",	"",	"",
	"",	"",	"",	"",
	"",	"",	"",	"",
	
	// Category Uniq IDs
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 
	
	// Last Uniq ID
	15,

	// Reserved
	0, 0,
	"None","ATM","POS","Check","Visa","M-Card","Discover","Amex","Food","Accom.","Mileage",
	"Car","Phone","Personal","Entert.","","","","","",
	"Food","Rent","Phone","","","","","","","","","","","","","","","","",""
	};


	
	if (DmOpenDatabaseInfo(dbP, &dbID, NULL, NULL, &cardNo, NULL))
		return dmErrInvalidParam;
	if (DmDatabaseInfo(cardNo, dbID, NULL, NULL, NULL, NULL, NULL, 
			NULL, NULL, &appInfoID, NULL, NULL, NULL))
		return dmErrInvalidParam;



	
	
	// If no appInfoID exists then we must create a new one.	
	if (appInfoID == NULL)
		{
		
		h = DmNewHandle (dbP, sizeof (MoneyAppInfoType));
		if (! h) return dmErrMemError;
		appInfoID = MemHandleToLocalID (h);
		DmSetDatabaseInfo(cardNo, dbID, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &appInfoID, NULL, NULL, NULL);

		}

	appInfoP = MemLocalIDToLockedPtr(appInfoID, cardNo);
	DmWrite(appInfoP, 0, &DefaultMoneyAppInfo, sizeof (MoneyAppInfoType));
	MemPtrUnlock(appInfoP);
	
	return 0;
	
	
}


static void ResetDate (void)
{
	TimSecondsToDateTime (TimGetSeconds (), &WorkingTransaction.date);
}

static Boolean SelectDate(void)
{
Short month,day,year;
Boolean dork;
month=WorkingTransaction.date.month;
day=WorkingTransaction.date.day;
year=WorkingTransaction.date.year;

if (dork=SelectDay (&month, &day, &year, "Select a date:"))
{
WorkingTransaction.date.month=month;
WorkingTransaction.date.day=day;
WorkingTransaction.date.year=year;
}
return dork;
}

static void SetTime(void)
{
TimeType theTime;
Boolean Untimed=false;
theTime.hours=WorkingTransaction.date.hour;
theTime.minutes=WorkingTransaction.date.minute;
	
if(SelectTime (&theTime, &theTime,
	Untimed, "Select a Time", 0)){
	if(theTime.hours==255){theTime.hours=0;theTime.minutes=0;};
	WorkingTransaction.date.hour=theTime.hours;
	WorkingTransaction.date.minute=theTime.minutes;
	
}
}

static void SetTop(Int Rec)
{
UInt recordNum;
recordNum=Rec;
if(DmSeekRecordInCategory (MoneyDB, &recordNum,4,
							dmSeekBackward, CurrentCategory)!=0)recordNum=0;
						CurrentRecord=TopVisibleRecord=recordNum;
}


static void InsertEvent(Int typeOfEvent,Int Button)
{
	EventType	newEvent;
   	MemSet(&newEvent, sizeof(EventType), 0);
   	newEvent.eType = typeOfEvent;
   	newEvent.data.ctlEnter.controlID = Button;
   	EvtAddEventToQueue(&newEvent);
}



static Boolean StartApplication(void)
{
	Int		error,x=5;
	UInt		cardNo;
	LocalID	dbID;
	UInt		dbAttrs;
	UInt		mode;

	SystemPreferencesType sysPrefs;
	MoneyPreferenceType prefs;
	Boolean recordFound = false;
	LocalID appInfoID;
	UInt version;
	DateTimeType currentDate;
	TimSecondsToDateTime (TimGetSeconds (), &currentDate);
	currentDate.hour=23;
	currentDate.minute=59;
	FplInit();
	x=DrawDot(x,2);
	// SInce we opened, recalculate the totals and resort.
	Resort=true;
	Recalculate=true;
	DrawHornet();
	FntSetFont (largeFont);
	WinDrawChars("PilotMoney 1.10",15,30,10);
	FntSetFont (stdFont);

	if (PrefGetAppPreferences (MoneyAppType, MoneyVersionNum, &prefs, 
		sizeof (MoneyPreferenceType)))
		{
		TopVisibleRecord = prefs.topVisibleRecord;
		CurrentCategory = prefs.currentCategory;
		RepeatBound = prefs.repeatBound;
		DollarSign = prefs.dollarSign;
		DisplayPref = prefs.displayPref;
		PrefFlags = prefs.prefflags;
		MainStatusChoise = prefs.mainstatuschoise;
		}
		
x=DrawDot(x,2);
		PrefGetPreferences (&sysPrefs);
	if (sysPrefs.hideSecretRecords)
		mode = dmModeReadWrite;
	else
		mode = dmModeReadWrite | dmModeShowSecret;
   x=DrawDot(x,2);
	ResetDate();
   JumpNote=false;
	// P5. Find the application's database.
	x=DrawDot(x,2);
	MoneyDB = DmOpenDatabaseByTypeCreator(MoneyDBType, MoneyAppType, mode);
	if (! MoneyDB)
		{
		// P5. The database doesn't exist, create it now.
		error = DmCreateDatabase(0, MoneyDBName, MoneyAppType, MoneyDBType, false);
		
		// P5. Check for error.  If the database couldn't be created report it.
		// The application should exit if the database couldn't be created.
		if (error)
			return true;
		
		// P5. Find the application's database.
		MoneyDB = DmOpenDatabaseByTypeCreator(MoneyDBType, MoneyAppType, mode);

		// P5. Get info about the database
		error = DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);

		// P5. Check for fatal error.
		ErrFatalDisplayIf(error, "Could not get database info.");
	
		// P5. Get attributes for the database
		error = DmDatabaseInfo(0, dbID, NULL, &dbAttrs, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

		// P5. Check for fatal error.
		ErrFatalDisplayIf(error, "Could not get database info.");
	
		// P17. Set the backup flag in the attributes
		// This will ensure that the database will always get backed up
		// during HotSync, even if there is no conduit for this application.
		dbAttrs = dbAttrs | dmHdrAttrBackup;

		// P5. Set the new attributes in the database
		error = DmSetDatabaseInfo(0, dbID, NULL, &dbAttrs, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

		// P5. Check for fatal error.
		ErrFatalDisplayIf(error, "Could not set database info.");
		
		// P11. Store category info in the application's information block.
		// If error return so.
		if (MoneyInitAppInfo(MoneyDB))
			return true;
		}
	else
		// P17. After a hard reset, the records may be sent to the device.
		// In this case the database might not have an app info block.
		// Check for an app info block, and if there isn't one create a
		// default one.
		{
		// P17. Get info about the database
		error = DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);

		// P17. Check for fatal error.
		ErrFatalDisplayIf(error, "Could not get database info.");
	
		// P17. Get attributes for the database.  This is an apropriate place
		// to get the version number of the database for applications which
		// have multiple versions of databases.  If the application detects
		// a different version of the database it may decide to not use it,
		// to translate it, or not support some new or old features.
		error = DmDatabaseInfo(0, dbID, NULL, NULL, &version, NULL, NULL, NULL, 
			NULL, &appInfoID, NULL, NULL, NULL);
		// P17. Check for fatal error.
		ErrFatalDisplayIf(error, "Could not get database info.");

		if (appInfoID == NULL)
			{
			// P17. Store category info in the application's information block.
			if (MoneyInitAppInfo(MoneyDB))
				return true;
			}
		}
	
	
	error = DmDatabaseInfo(0, dbID, NULL, &dbAttrs, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	ErrFatalDisplayIf(error, "Could not get database info.");
	dbAttrs = dbAttrs | dmHdrAttrBackup;
	error = DmSetDatabaseInfo(0, dbID, NULL, &dbAttrs, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);


x=DrawDot(x,2);

	// P11. Get the name of the current category from the app info block.
	// The app info block was created and initialized by MoneyInitAppInfo.
	CategoryGetName (MoneyDB, CurrentCategory, CategoryName);

	// P17. The category may no longer exist if it was removed during a sync
	if (*CategoryName == 0)
		{
		CurrentCategory = dmAllCategories;
		}

	CurrentRecord=noRecordSelected;
	
	
	// P16. Count the records later when needed to display.
	MemosInCategory = memosInCategoryUnknown;
	x=DrawDot(x,2);
		Scan(1,true,WorkingTransaction.date,0);
	x=DrawDot(x,2);
	
	if (sysPrefs.hideSecretRecords)if(PrefFlags & 1){
		FrmAlert(1098);
		return true;
		}
	
	// P4. Set current view so the first form to display is the main form.
	CurrentView = mainForm;
	x=DrawDot(x,2);
	
	if((DisplayPref & 8)==8)Recur(true); // Preferences say we need to enter repating transactions
	x=DrawDot(x,2);
	CurrentRecord = Scan(4,false,currentDate,0); // We want to position th screen to today's date
	if (CurrentRecord == noRecordSelected){
		TopVisibleRecord = 0;
		CurrentRecord = noRecordSelected;
		}
	else SetTop(CurrentRecord);
	x=DrawDot(x,2);

	
	

	
	return false;
}



static VoidPtr GetObjectPtr(Int objectID)
{
	FormPtr frm;
	
	frm = FrmGetActiveForm();
	return(FrmGetObjectPtr(frm, FrmGetObjectIndex(frm, objectID)));
}




static void ChangeCategory (Word category)
{
	// Remember what category the record is in.
	RecordCategory = category;
	
	// P16. Count the records later when needed to display.
	MemosInCategory = memosInCategoryUnknown;

	// The editForm should be updated to display the new category.
	// Send a frmUpdateEvent with our updateCategoryChanged code
	// which we defined. 
	FrmUpdateForm (editForm, updateCategoryChanged);
}


static void MyAdjust(DateTimeType * workingdate, UInt days)
// the internal time adjust fn's dont span the times we need... so....
{
while(days>0){
workingdate->day++;
days--;
if(workingdate->day>DaysInMonth(workingdate->month,workingdate->year)){
		workingdate->day-=DaysInMonth(workingdate->month,workingdate->year);
		workingdate->month++;

if(workingdate->month>12){
		workingdate->month-=12;
		workingdate->year++;
		}
	}
}
}



		
static Int DupeIt(Word repeatType, Int recnum, UInt category)
{
	VoidHand memoRec,recHandle;
	TransactionTypePtr ptr;
	UInt		attr,index = 0;
	Char		zero = 0, days=0,anyadded=0,added=1;
	DateTimeType oldDate,nextDate,currentDate;
	
	// Get today's date.
	
	TimSecondsToDateTime (TimGetSeconds (), &currentDate);
	MyAdjust(&currentDate,RepeatBound); // Get the last possible day to replicate to
	oldDate=WorkingTransaction.date;
while(added==1){ // keep going until we have no more.
	added=0;
	
	
	  
	
	switch (repeatType)
			{
			case 1:
					MyAdjust(&WorkingTransaction.date,7);
					nextDate=WorkingTransaction.date;
					MyAdjust(&nextDate,7);
			break;
			
			case 2:
					MyAdjust(&WorkingTransaction.date,14);
					nextDate=WorkingTransaction.date;
					MyAdjust(&nextDate,14);
			break;
			case 3:
					WorkingTransaction.date.month++;
					if(WorkingTransaction.date.month>12){
							WorkingTransaction.date.month=1;
							WorkingTransaction.date.year++;
							}
			nextDate=WorkingTransaction.date;
			nextDate.month++;
					if(nextDate.month>12){
							nextDate.month=1;
							nextDate.year++;
							}
			break;
			case 4:
					WorkingTransaction.date.month++;
					if(WorkingTransaction.date.month>12){
							WorkingTransaction.date.month=1;
							WorkingTransaction.date.year++;
							}
					WorkingTransaction.date.day=DaysInMonth(WorkingTransaction.date.month,WorkingTransaction.date.year);
					
			nextDate=WorkingTransaction.date;
			nextDate.month++;
					if(nextDate.month>12){
							nextDate.month=1;
							nextDate.year++;
							}
					nextDate.day=DaysInMonth(nextDate.month,nextDate.year);
					
			break;
			default: 
					MyAdjust(&WorkingTransaction.date,7);
					nextDate=WorkingTransaction.date;
					MyAdjust(&nextDate,7);
			break;
				
			}

if (DateTypeCmp(WorkingTransaction.date,currentDate,true)<0){
			anyadded=1;
			added=1; // We need to still add one.
			if (DateTypeCmp(nextDate,currentDate,true)>=0)WorkingTransaction.repeat=repeatType;
			else WorkingTransaction.repeat=0;
							


	memoRec = DmNewRecord(MoneyDB, &index, sizeof(TransactionType));
	if(!memoRec)FrmAlert(1097);
	else
	{
			ptr = MemHandleLock(memoRec);

			DmWrite(ptr, 0, &WorkingTransaction, sizeof(TransactionType)-400+StrLen(WorkingTransaction.note)	);
			MemHandleUnlock(memoRec);
	
	DmRecordInfo (MoneyDB, index, &attr, NULL, NULL);
	attr &= ~dmRecAttrCategoryMask;
	attr |= category;
	DmSetRecordInfo (MoneyDB, index, &attr, NULL);
	if (MemosInCategory != memosInCategoryUnknown)
		MemosInCategory++;			//   P16. the category has gained one record
	}
	DmReleaseRecord(MoneyDB, index, true);
		
}
  }
  if(anyadded==0){
  		recHandle = DmGetRecord(MoneyDB, recnum);
		ptr=MemHandleLock(recHandle);
			WorkingTransaction.repeat=repeatType;
			WorkingTransaction.date=oldDate;
			DmWrite(ptr, 0, &WorkingTransaction,  sizeof(TransactionType)-400+StrLen(WorkingTransaction.note));
			MemHandleUnlock(recHandle);
			DmReleaseRecord(MoneyDB, recnum, true);
			}
	return(anyadded);	
}



static Boolean CreateRecord(Boolean Duplicate)
{
	VoidHand memoRec;
	UInt		index = 0;
	Char		zero = 0;
	UInt		attr;

	
	memoRec = DmNewRecord(MoneyDB, &index, sizeof(TransactionType)-399);
	if(!memoRec)FrmAlert(1097); else {
	if(Duplicate==false){
	WorkingTransaction.checknum=0;
	WorkingTransaction.amount=0;
	WorkingTransaction.total=0;
	WorkingTransaction.flags2=0;
	WorkingTransaction.type=0;
	for(zero=0;zero<3;++zero)WorkingTransaction.reserved[zero]=0;zero=0;
	WorkingTransaction.amountc=0;
	WorkingTransaction.totalc=0;
	WorkingTransaction.description[0]='\0';
	WorkingTransaction.note[0]='\0';
	WorkingTransaction.repeat=0;
	WorkingTransaction.flags=0;
	ResetDate();}
	CompressedWrite(&index,WorkingTransaction);
	
	// P11. Set the category of the new record to the current category.
	DmRecordInfo (MoneyDB, 0, &attr, NULL, NULL);
	attr &= ~dmRecAttrCategoryMask;				// Remove all category bits
	if (CurrentCategory == dmAllCategories)
		{
		attr |= dmUnfiledCategory;
		}
	else
		{
		attr |= CurrentCategory;
		}
	DmSetRecordInfo (MoneyDB, 0, &attr, NULL);

	if (MemosInCategory != memosInCategoryUnknown)
		MemosInCategory++;
	DmReleaseRecord(MoneyDB, 0, true);
	CurrentRecord =0;

	Resort=true;
	Recalculate=true;}
		return(true);	
}


static FieldPtr GetFocusObjectPtr(void)
{
	FormPtr frm;
	Int focus;
	
	// Get a pointer to tha active form and the index of the form object with focus.
	frm = FrmGetActiveForm();
	focus = FrmGetFocus(frm);
	
	// If no object has the focus return NULL pointer.
	if (focus == noFocus)
		return(NULL);
		
	// Return a pointer to the object with focus.
	return(FrmGetObjectPtr(frm, focus));
}




static void EditViewSetTitle (void)
{
	CharPtr titleTemplateP;
	CharPtr textStart;		// start of the text part we copy
	CharPtr textEnd;			// end of the text part we copy
	CharPtr endOfNewTitle;
	FormPtr frm;
	Char posStr [digitsForRecordPosition + 1];
	Char totalStr [digitsForRecordPosition + 1];
	UInt pos;
	UInt length;
	

	// Format as strings, the memo's postion within its category, and 
	// the total number of memos in the category.
	pos = DmPositionInCategory (MoneyDB, CurrentRecord, RecordCategory);
	StrIToA (posStr, pos+1);

	// P16. Count the records if unknown.  Remember this routine takes account
	// of private records.
	if (MemosInCategory == memosInCategoryUnknown)
		MemosInCategory = DmNumRecordsInCategory (MoneyDB, RecordCategory);
	StrIToA (totalStr, MemosInCategory);


	// Get the title template string.  It contains '#' chars which we replace
	// with the position of CurrentRecord within CurrentCategory and with
	// the total count of records in CurrentCategory ().
	titleTemplateP = MemHandleLock (DmGetResource (strRsc, editTitleString));


	// Free any old title.  Also done when the form is closed in EditViewHandleEvent.
	if (EditViewTitlePtr)
		MemPtrFree(EditViewTitlePtr);

	// Now get space for the new title.  Subtract 2 (the number of '#' chars).
	length = StrLen (posStr) + StrLen (totalStr) + StrLen (titleTemplateP) - 2;
	EditViewTitlePtr = MemPtrNew (length);
	ErrFatalDisplayIf (!EditViewTitlePtr, "Out of memory");
	endOfNewTitle = EditViewTitlePtr;


	// Copy text 1
	textStart = titleTemplateP;
	textEnd = StrChr (textStart, titleReplacementChar);
	length = textEnd - textStart;
	MemMove (endOfNewTitle, textStart, length);
	endOfNewTitle[length] = 0;
	endOfNewTitle += length;
	
	// Copy arg 1
	StrCopy(endOfNewTitle, posStr);
	endOfNewTitle += StrLen(endOfNewTitle);

	
	// Copy text 2
	textStart = textEnd + sizeof((Char) titleReplacementChar);
	textEnd = StrChr (textStart, titleReplacementChar);
	length = textEnd - textStart;
	MemMove (endOfNewTitle, textStart, length);
	endOfNewTitle[length] = 0;
	endOfNewTitle += length;
	
	// Copy arg 2
	StrCopy(endOfNewTitle, totalStr);
	endOfNewTitle += StrLen(endOfNewTitle);

	
	// Copy text 3
	textStart = textEnd + sizeof((Char) titleReplacementChar);
	StrCat(endOfNewTitle, textStart);

	
	// Now set the title to use the new title string.
	frm = FrmGetFormPtr (editForm);
	FrmSetTitle (frm, EditViewTitlePtr);
	MemPtrUnlock(titleTemplateP);
}






static Boolean EditViewUpdateDisplay (Int updateCode)
{
	RectangleType rect;

	FormPtr frm;
	Char dateStr [20];
	Word len;
	SystemPreferencesType sysPrefs;


	PrefGetPreferences (&sysPrefs);
	frm = FrmGetActiveForm ();
rect.topLeft.x=40;
rect.topLeft.y=24;
rect.extent.x=49;
rect.extent.y=15;

		WinEraseRectangle(&rect,0);
rect.topLeft.x=122;
rect.topLeft.y=24;
rect.extent.x=39;
rect.extent.y=15;

		WinEraseRectangle(&rect,0);

		DateToAscii (WorkingTransaction.date.month, 
				 		 WorkingTransaction.date.day, 
				 		 WorkingTransaction.date.year, 
				 		 sysPrefs.dateFormat, &dateStr[0]);
		len = StrLen (dateStr);
		FntSetFont (stdFont);
		WinDrawChars (dateStr, len, 40, 24);
		
		TimeToAscii(WorkingTransaction.date.hour,WorkingTransaction.date.minute,true,&dateStr[0]);
		len = StrLen (dateStr);
		WinDrawChars (dateStr, len, 122, 24);
		CategoryGetName (MoneyDB, RecordCategory, CategoryName);
		CategorySetTriggerLabel (GetObjectPtr (editCategoryTrigger),
			CategoryName);
	
	if (updateCode == updateCategoryChanged)
		{
		EditViewSetTitle ();
		
		if (CurrentCategory != dmAllCategories &&
			CurrentCategory != RecordCategory)
			CurrentCategory = RecordCategory;
			
		return (true);
		}
	
	return (false);
}






static void EditViewSelectCategory (void)
{
	UInt attr;
	FormPtr frm;
	UInt category;
	Boolean categorySelected;
	Boolean categoryEdited;


	// Get the current category.	
	category = RecordCategory;
	
	// Process the category popup list.
	frm = FrmGetActiveForm();
	
	// Have the system ui present the user with a list of categories
	// and return what the user selects.
	categoryEdited = CategorySelect (MoneyDB, frm, editCategoryTrigger,
					  editCategoryList, false, &category, CategoryName);


	categorySelected = (category != RecordCategory);

	// If a different category was selected, set the category field
	// in the new record.
	if (categorySelected)
		{
		// Change the category of the record.
		DmRecordInfo (MoneyDB, CurrentRecord, &attr, NULL, NULL);	
		attr &= ~dmRecAttrCategoryMask;
		attr |= (category | dmRecAttrDirty);
		DmSetRecordInfo (MoneyDB, CurrentRecord, &attr, NULL);
		}


	// If the current category was changed or the name of the category 
	// was edited,  draw the title.
	if (categoryEdited || categorySelected)
		{
		ChangeCategory (category);
		EditViewSetTitle ();	
		
		}
}



static void GoToRecord (GoToParamsPtr goToParams, Boolean launchingApp)
{
	Word recordNum;
	UInt attr;
	ULong uniqueID;
	EventType event;


	recordNum = goToParams->recordNum;
	if(goToParams->matchFieldNum==2)JumpNote=true;
	DmRecordInfo (MoneyDB, recordNum, &attr, &uniqueID, NULL);

	// Change the current category if necessary.
	if (CurrentCategory != dmAllCategories)
		{
		ChangeCategory (attr & dmRecAttrCategoryMask);
		}


	// If the application is already running, close all open forms.  
	// Because closing forms sometimes writes data to a record which
	// could affect the ordering of records in the database, the record
	// is looked up by it's unique id which is unaffected by changing
	// data and database ordering.
	if (! launchingApp)
		{
		FrmCloseAllForms ();
		DmFindRecordByID (MoneyDB, uniqueID, &recordNum);
		}
		

	// Send events to load and goto a form selecting the matching text.
	MemSet (&event, sizeof(EventType), 0);

	event.eType = frmLoadEvent;
	event.data.frmLoad.formID = editForm;
	EvtAddEventToQueue (&event);
 
	event.eType = frmGotoEvent;
	event.data.frmGoto.recordNum = recordNum;
	event.data.frmGoto.matchPos = goToParams->matchPos;
	event.data.frmGoto.matchLen = goToParams->searchStrLen;
	event.data.frmGoto.matchFieldNum = goToParams->matchFieldNum;
	event.data.frmGoto.formID = editForm;
	EvtAddEventToQueue (&event);
}

static void Search (FindParamsPtr findParams)
{
	Word pos;
	CharPtr header;
	UInt recordNum;
	VoidHand recordH;
	VoidHand headerH;
	RectangleType r;
	Boolean done;
	Boolean match;
	DmOpenRef dbP;
	UInt cardNo = 0;
	LocalID dbID;
	TransactionType  *MoneyRecP;
	Char temp[20],dorq;

	// Find the application's data file.
	dbP = DmOpenDatabaseByTypeCreator(MoneyDBType, MoneyAppType, findParams->dbAccesMode);
	if (!dbP)
		{
		// Return without anything.  Also indicate that no more records are expected.
		findParams->more = false;
		return;
		}
	DmOpenDatabaseInfo(dbP, &dbID, 0, 0, &cardNo, 0);

	// Display the heading line.
	headerH = DmGetResource (strRsc, findMoneyHeaderStr);
	header = MemHandleLock (headerH);
	done = FindDrawHeader (findParams, header);
	MemHandleUnlock (headerH);
	if (done) goto Exit;				// There was no more room to display the heading line
	

	// Search the records for the string.  We start with the recordNum passed.
	// This allows the search code to be called multiple times when more than
	// one screen of records are found.
	recordNum = findParams->recordNum;
	while (true)
		{
		// Get the next record.  Skip private records if neccessary.
		recordH = DmQueryNextInCategory (dbP, &recordNum, dmAllCategories);

		// Have we run out of records?
		if (! recordH)
			{
			findParams->more = false;			
			break;
			}

		MoneyRecP = MemHandleLock (recordH);
		 
		// Search for the string passed,  if it's found display the title
		// of the memo.  An application should call FindStrInStr
		// for each part of the record which needs to be searched.
		StrIToA(temp,MoneyRecP->checknum);dorq=0;
		match = FindStrInStr (MoneyRecP->description, findParams->strToFind, &pos);
		if(match==false)if(match = FindStrInStr (temp, findParams->strToFind, &pos))dorq=1;
		if(match==false)if(match = FindStrInStr (MoneyRecP->note, findParams->strToFind, &pos))dorq=2;
		if (match)
			{
			// Add the match to the find parameter block,  if there is no room to
			// display the match the following function will return true.
			done = FindSaveMatch (findParams, recordNum, pos, dorq, 0, cardNo, dbID);

			if (! done)
				{
				// Get the bounds of the region where we will draw the results.
				FindGetLineBounds (findParams, &r);
				
				// Display the record in the search dialog.  We move in one pixel
				// so that when the record is inverted the left edge is solid.
				r.topLeft.x++;
				r.extent.x--;
				MainViewDrawRecordInBounds(MoneyRecP, &r,true);
	
				// The line number needs to be increment since a line is used for the record.
				findParams->lineNumber++;
				}
			}
		MemHandleUnlock (recordH);

		if (done) break;
		recordNum++;
		}
		
		
Exit:
	DmCloseDatabase (dbP);	
}




static Boolean EditViewDeleteCurrentRecord(void)
{


	if (FrmAlert(editDeleteAlert) == editDeleteOK)
		{
			DeleteIt=true;
		return(true);
		}
	
	
		return(false);
}

static Int DateTypeCmp(DateTimeType d1, DateTimeType d2, Boolean FullCompare)
{
	Int result;
	
	result = d1.year - d2.year;
	if (result != 0)
		{
		if ((*(Int *) &d1) == -1)
			return 1;
		if ((*(Int *) &d2) == -1)
			return -1;
		return result;
		}
	
	result = d1.month - d2.month;
	if (result != 0)
		return result;
	
	result = d1.day - d2.day;
	if (result != 0)
		return result;
	
	if(FullCompare==true){
	result = d1.hour - d2.hour;
	if (result != 0)
		return result;
	
	result = d1.minute - d2.minute;
	if (result != 0)
		return result;
	
	result = d1.second - d2.second;
	if (result != 0)
		return result;
	}
	
	
	return result;

}


static Int MoneyCompareRecords(TransactionTypePtr r1, 
	TransactionTypePtr r2)
{
	Int result;
		result = DateTypeCmp(r1->date, r2->date,true);
		
	
	return result;
}



static void EditViewSaveData(void)
{
	VoidHand	fldHandle;
	ListPtr lst;
	FieldPtr fld;
   CharPtr textP;
   Char temp[20];
   Byte	IsNegative;
	UInt		attr;
	Boolean	secret;
	
		DmRecordInfo(MoneyDB, CurrentRecord, &attr, NULL, NULL);
		secret = (CtlGetValue(GetObjectPtr(editPrivateChkbx)) != 0);
		if (secret)
			attr |= dmRecAttrSecret;
		else
			attr &= ~dmRecAttrSecret;
		attr |= dmRecAttrDirty;
		DmSetRecordInfo (MoneyDB, CurrentRecord, &attr, NULL);
		
		
		
		fld=GetObjectPtr(editField);
		fldHandle=FldGetTextHandle(fld);
		textP = MemHandleLock(fldHandle);
		StrCopy(WorkingTransaction.description,textP);
		MemHandleUnlock(fldHandle);
		
		
		if(CtlGetValue(GetObjectPtr(editReceiptCheckbox))==1)WorkingTransaction.flags2=WorkingTransaction.flags2 | 1;
		else WorkingTransaction.flags2=WorkingTransaction.flags2 & 254;
		
		if(CtlGetValue(GetObjectPtr(editClearedCheck))==1)WorkingTransaction.flags=WorkingTransaction.flags | 1;
		else WorkingTransaction.flags=WorkingTransaction.flags & 254;
		
		if(CtlGetValue(GetObjectPtr(editQIFChkbx))==0)WorkingTransaction.flags=WorkingTransaction.flags | 2;
		else WorkingTransaction.flags=WorkingTransaction.flags & 253;
		
		
		
		
		fld=GetObjectPtr(checkField);
		if(FldGetTextLength(fld)>0){
		fldHandle=FldGetTextHandle(fld);
		textP = MemHandleLock(fldHandle);
		StrCopy(temp,textP);
		WorkingTransaction.checknum=MyStrAToI(temp);
		MemHandleUnlock(fldHandle);
		} else WorkingTransaction.checknum=0;

		fld=GetObjectPtr(amountField);
		if(FldGetTextLength(fld)>0){
		fldHandle=FldGetTextHandle(fld);
		textP = MemHandleLock(fldHandle);
		StrCopy(temp,"0.00");
		StrCopy(temp,textP);
		WorkingTransaction.amount=MyStrAToI(temp);
		WorkingTransaction.amountc=MyStrAToI2(temp);
		MemHandleUnlock(fldHandle);
		lst = GetObjectPtr (editRepeatList);
		WorkingTransaction.repeat=LstGetSelection (lst);
		lst = GetObjectPtr (editTypeList);
		WorkingTransaction.type=LstGetSelection (lst);
		lst = GetObjectPtr (drcrList);
		IsNegative=LstGetSelection (lst);
		if(IsNegative==0){
				WorkingTransaction.amountc=WorkingTransaction.amountc*-1;
				WorkingTransaction.amount=WorkingTransaction.amount*-1;
				}
		} else {WorkingTransaction.amount=0;
		WorkingTransaction.amountc=0;
		}
		
		if (	(OldTransaction.flags!=WorkingTransaction.flags) | 
				(OldTransaction.flags2!=WorkingTransaction.flags2) | 
				(OldTransaction.amount!=WorkingTransaction.amount) | 
				(OldTransaction.repeat!=WorkingTransaction.repeat) | 
				(OldTransaction.type!=WorkingTransaction.type) | 
				(OldTransaction.amountc!=WorkingTransaction.amountc) | 
				(OldTransaction.checknum!=WorkingTransaction.checknum) | 
				(StrCompare(OldTransaction.description,WorkingTransaction.description)!=0) | 
				(StrCompare(OldTransaction.note,WorkingTransaction.note)!=0) | 
				(DateTypeCmp(OldTransaction.date,WorkingTransaction.date,true)!=0)
					){ 
		if(DateTypeCmp(OldTransaction.date,WorkingTransaction.date,true)!=0)Resort=true;
		
		CompressedWrite(&CurrentRecord,WorkingTransaction);
		DmReleaseRecord(MoneyDB, CurrentRecord,true);
		if((OldTransaction.amount!=WorkingTransaction.amount) | 
				(OldTransaction.amountc!=WorkingTransaction.amountc) |
				(DateTypeCmp(OldTransaction.date,WorkingTransaction.date,true)!=0)) 
				Recalculate=true;
		}
		
		if(DeleteIt==true){
		DmRemoveRecord(MoneyDB, CurrentRecord); // DmDelete instead 
		Recalculate=true;
		CurrentRecord = noRecordSelected;
		if (MemosInCategory != memosInCategoryUnknown)
			MemosInCategory--;
		DeleteIt=false;
		}

		
		SortIt();
		
}


/***********************************************************************
 *
 * FUNCTION:		EditViewRetrieveData
 *
 * DESCRIPTION:	P5. Retrieves the data from the first record of a database 
 *						and places it in a field.
 *
 * PARAMETERS:		fld - the field to contain the text.
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void EditViewRetrieveData(void)
{
	VoidHand	recHandle,textH;
	UInt attr;
	FieldPtr fld;
	ControlPtr ctl;
	ListPtr lst;
	Char temp[20];
	TransactionTypePtr	ptr;
	CharPtr textP;
	Boolean 		secret;


	if (CurrentRecord != noRecordSelected && DmNumRecords(MoneyDB) > 0)
		{
		// Get a handle for the first record.
		DmRecordInfo(MoneyDB, CurrentRecord, &attr, NULL, NULL);
		secret = attr & dmRecAttrSecret;
		CtlSetValue(GetObjectPtr(editPrivateChkbx), secret);

		recHandle = DmGetRecord(MoneyDB, CurrentRecord);
		if(recHandle){ptr=MemHandleLock(recHandle);
		WorkingTransaction=PtrToStruct(ptr);
		MemHandleUnlock(recHandle);
		
	// Now we set the damn fields up...
			fld=GetObjectPtr(editField);
			textH = MemHandleNew(21);
			if (textH)
				{
				textP = MemHandleLock(textH);
				StrCopy(textP, WorkingTransaction.description);
				FldSetTextHandle (fld, textH);
				MemHandleUnlock(textH);
				}
			
			
					fld=GetObjectPtr(amountField);
					textH = MemHandleNew(20);
			
					StrCopy(temp,"\0");
					if((WorkingTransaction.amount!=0) | (WorkingTransaction.amountc!=0))ConvertAmount(temp,WorkingTransaction.amount,WorkingTransaction.amountc,false,true);
						if (textH)
							{
							textP = MemHandleLock(textH);
							StrCopy(textP, temp);
							FldSetTextHandle (fld, textH);
							MemHandleUnlock(textH);
							}
			
			fld=GetObjectPtr(totalField);
			textH = MemHandleNew(20);
			
			
			ConvertAmount(temp,WorkingTransaction.total,WorkingTransaction.totalc,true,true);
			if (textH)
				{
				textP = MemHandleLock(textH);
				StrCopy(textP, temp);
				FldSetTextHandle (fld, textH);
				MemHandleUnlock(textH);
				}
			
			fld=GetObjectPtr(checkField);
			textH = MemHandleNew(10);
			if (WorkingTransaction.checknum<0)WorkingTransaction.checknum=0;
			if (WorkingTransaction.checknum>9999)WorkingTransaction.checknum=0;
			MyStrIToA(temp,WorkingTransaction.checknum);
			if(WorkingTransaction.checknum==0)StrCopy(temp,"\0\0\0");
			if (textH)
				{
				textP = MemHandleLock(textH);
				StrCopy(textP, temp);
				FldSetTextHandle (fld, textH);
				MemHandleUnlock(textH);
				}
			
			
			lst = GetObjectPtr (editRepeatList);
			LstSetSelection (lst, WorkingTransaction.repeat);
			CategorySetTriggerLabel ( GetObjectPtr (repeatTrigger),LstGetSelectionText( GetObjectPtr (editRepeatList),WorkingTransaction.repeat));
			
			
			lst = GetObjectPtr (editTypeList);
			if(WorkingTransaction.type>LstGetNumberOfItems(lst)-1)WorkingTransaction.type=0;
			LstSetSelection (lst, WorkingTransaction.type);
			CategorySetTriggerLabel ( GetObjectPtr (typeTrigger),LstGetSelectionText( GetObjectPtr (editTypeList),WorkingTransaction.type));
			
			
		ctl = GetObjectPtr (drcrTrigger);
		if((WorkingTransaction.amount>0) | (WorkingTransaction.amountc>0))CategorySetTriggerLabel (ctl,"CR:" );
			else CategorySetTriggerLabel (ctl,"DR:" );
		lst = GetObjectPtr (drcrList);
		if((WorkingTransaction.amount>0) | (WorkingTransaction.amountc>0))LstSetSelection (lst, 1);
		else LstSetSelection (lst, 0);
		
		if((WorkingTransaction.flags & 1)==1)CtlSetValue(GetObjectPtr(editClearedCheck), 1); else 
			CtlSetValue(GetObjectPtr(editClearedCheck), 0);
		
		if((WorkingTransaction.flags & 2)==2)CtlSetValue(GetObjectPtr(editQIFChkbx), 0); else 
			CtlSetValue(GetObjectPtr(editQIFChkbx), 1);
		
		if((WorkingTransaction.flags2 & 1)==1)CtlSetValue(GetObjectPtr(editReceiptCheckbox), 1);
		else	CtlSetValue(GetObjectPtr(editReceiptCheckbox), 0);
		DmRecordInfo (MoneyDB, CurrentRecord, &attr, NULL, NULL);
		RecordCategory = attr & dmRecAttrCategoryMask;
		
		
		EditViewSetTitle ();
		
		EditViewUpdateDisplay(0);
		DmReleaseRecord(MoneyDB, CurrentRecord, false);
		OldTransaction=WorkingTransaction;
		
		
		}
		}
		DrawNote();
}





static void FlipRecord(void)  // Mark a record "Cleared"
{
	VoidHand	recHandle;
	TransactionTypePtr	ptr;
	if (CurrentRecord != noRecordSelected && DmNumRecords(MoneyDB) > 0)
		{
		// Get a handle for the first record.
		recHandle = DmGetRecord(MoneyDB, CurrentRecord);
		ptr=MemHandleLock(recHandle);
		WorkingTransaction=PtrToStruct(ptr);
		if ((WorkingTransaction.flags & 1)==1)WorkingTransaction.flags&=254;
		else WorkingTransaction.flags|=1;
		DmWrite(ptr, 0, &WorkingTransaction, sizeof(TransactionType)-400+StrLen(WorkingTransaction.note));
		MemHandleUnlock(recHandle);
		DmReleaseRecord(MoneyDB, CurrentRecord,true);
		
		}
		
}

static void EditViewDoMenuCommand(Int command)
{
	FieldPtr	fld;
	FormPtr	frm;

	// Do the appropriate action for the menu command selected.
	switch (command)
		{
		case newPageCmd:		// P9. Create a new memo page.
			// Save the current data in the field.
			Recalculate=false;
			Resort=false;
			EditViewSaveData();
			if (CreateRecord(false))
   					EditViewRetrieveData();
   		FrmDrawForm(FrmGetActiveForm());
			break;
		
		case duplicatePageCmd:		// P9. Create a new memo page.
			// Save the current data in the field.
			Recalculate=false;
			Resort=false;
			EditViewSaveData();
				if (CreateRecord(true))
	   		// Get the data for the field from the application's database.
   			EditViewRetrieveData();
   		break;
		
		case deletePageCmd:	// P9. Delete the current memo page.
			// P10. Delete the current database record.
			if (EditViewDeleteCurrentRecord())
	   		// Go back to the main form.
				FrmGotoForm(mainForm);
			break;
			
		case getInfoCmd:		// Display the info form.
			// Load the info form, then display it.
			frm = FrmInitForm(infoForm);
			FrmDoDialog(frm);
			
			// Delete the info form.
	 		FrmDeleteForm(frm);
			break;
		
	case cutCmd:			// Do a cut to the clipboard if text is highlighted.
			fld = GetFocusObjectPtr();
			if (fld)
				{
				FldCut(fld);
				}
			break;
		
		case copyCmd:			// Copy the highlighted text to the clipboard.
			fld = GetFocusObjectPtr();
			if (fld)
				{
				FldCopy(fld);	
				}
			break;
		
		case pasteCmd:			// Do a paste from the clipboard.
			fld = GetFocusObjectPtr();
			if (fld)
				{
				FldPaste(fld);		
				}
			break;
			
		case undoCmd:			// Undo the last text change.
			fld = GetFocusObjectPtr();
			if (fld)
				{
				FldUndo(fld);
				}
			break;
		
		case selectAllCmd:	// Select all the existing text.
			fld = GetFocusObjectPtr();
			if (fld)
				FldSetSelection(fld, 0, FldGetTextLength(fld));
			break;
			
		case keyboardCmd:		// Display the on screen keyboard.
			SysKeyboardDialog();
			break;
		}	
}


static Boolean EditViewHandleEvent(EventPtr event)
{
	Int		fldIndex;
	Boolean	handled = false;
	FormPtr	frm;
	Word recordNum;
	ListPtr	lst;
	FieldPtr	fld;
	VoidHand textH;
	 CharPtr textP;
	

	
		switch (event->eType)
	{
		case ctlSelectEvent:
	   	if (event->data.ctlEnter.controlID == editDoneButton)
	   		{
				FrmGotoForm(mainForm);
				handled = true;
				}
			else if (event->data.ctlEnter.controlID == editNoteButton)
	   		{
				FrmPopupForm(noteForm);
				
			handled = true;
				}
			else if (event->data.ctlEnter.controlID == editTransferButton)
				{
				if (EditViewDeleteCurrentRecord())
					{
					FrmCloseAllForms();
					FrmGotoForm(mainForm);
					}
				}

	   	
	   	else if (event->data.ctlEnter.controlID == selectDateButton)
				{
				
				if(SelectDate())
				EditViewUpdateDisplay (0);
				
				handled = true;
				}
			else if (event->data.ctlEnter.controlID == editTimeButton)
				{
				
				SetTime();
				EditViewUpdateDisplay (0);
				
				handled = true;
				}

	   	else if (event->data.ctlEnter.controlID == editCategoryTrigger)
				{
				
				EditViewSelectCategory ();
				handled = true;
				}
			break;
			
		case popSelectEvent:
	   		
			if (event->data.ctlEnter.controlID == editDescTrigger)
				{
				
				lst = GetObjectPtr (editDescList);
				CategorySetTriggerLabel ( GetObjectPtr (editDescTrigger)," \0");
				fld=GetObjectPtr(editField);
				textH = MemHandleNew(21);
				if (textH)
						{
						textP = MemHandleLock(textH);
						StrCopy(textP, LstGetSelectionText( GetObjectPtr (editDescList),LstGetSelection(lst)));
						FldSetTextHandle (fld, textH);
						MemHandleUnlock(textH);
						FrmDrawForm(FrmGetActiveForm ());
						}
				
				handled = true;
				}
				
			  break;
  	

   	
  		case frmUpdateEvent:
			handled =  EditViewUpdateDisplay (event->data.frmUpdate.updateCode);
			DrawNote();
			break;


  		case frmGotoEvent:
  			SetTypeList();
  			ClearScreen();
			frm=FrmGetActiveForm ();
			CurrentRecord = event->data.frmGoto.recordNum;
			EditViewRetrieveData();
			CurrentCategory=RecordCategory;
   		EditViewUpdateDisplay (0);
			FrmDrawForm(frm);
			DrawNote();
			if(JumpNote){
  					FrmPopupForm(noteForm);
  					JumpNote=false;
  					}
  			handled = true;
			break;
			
  		case frmOpenEvent:
  			SetTypeList();
  			EditViewRetrieveData();
			frm = FrmGetActiveForm ();
  			FrmDrawForm(frm);
  			if(JumpNote){
  					FrmPopupForm(noteForm);
  					JumpNote=false;
  					}
  					else FrmSetFocus (frm, FrmGetObjectIndex (frm, editField));
  			handled = true;
			break;
			
  		case keyDownEvent:
	   	if (event->data.keyDown.chr == pageUpChr)
	   		{
	   		recordNum = CurrentRecord;
				if(DmSeekRecordInCategory (MoneyDB, &recordNum,1,
				dmSeekBackward, CurrentCategory)==0){
					EditViewSaveData();
					CurrentRecord=recordNum;
					WorkingTransaction.checknum=0;
					EditViewRetrieveData();
					frm = FrmGetActiveForm ();
  					FrmDrawForm(frm);
  					
					}
	   		handled = true;
	   		}
	   	else if (event->data.keyDown.chr == pageDownChr)
	   		{
	   		recordNum = CurrentRecord;
	   		if(DmSeekRecordInCategory (MoneyDB, &recordNum,1,
				dmSeekForward, CurrentCategory)==0){
					EditViewSaveData();
					CurrentRecord=recordNum;
					WorkingTransaction.checknum=0;
					EditViewRetrieveData();
					frm = FrmGetActiveForm ();
  					FrmDrawForm(frm);
					}
	   		handled = true;
	   		}
			break;
		
		case menuEvent:		// P4. A menu item was selected.
			// First clear the menu status from the display.
			MenuEraseStatus(0);
			
			// Process menu commands for the edit form.
			EditViewDoMenuCommand(event->data.menu.itemID);
			handled = true;
			break;


		case frmCloseEvent:
  			frm = FrmGetActiveForm();
   		fldIndex = FrmGetObjectIndex(frm, editField);
   		EditViewSaveData();
   		CurrentRecord = Scan(4,false,WorkingTransaction.date,0);
			if (CurrentRecord == noRecordSelected){
				TopVisibleRecord = 0;
				CurrentRecord = noRecordSelected;
				}
				else SetTop(CurrentRecord);
   		
   		if (EditViewTitlePtr)
				{
				MemPtrFree(EditViewTitlePtr);
				EditViewTitlePtr = NULL;
				}
			break;
	}
	return(handled);
}





static void Parse(Int TypeOfParse,Int SubCategory)
{
	ULong RecordNum,MaxRecords;
	UInt cardNo;
	UInt RecCatagory,attr;
	LocalID dbID;
	VoidHand	recHandle;
	Int BalNumber;

		TransactionTypePtr	ptr;
	TransactionType	CurrentTransaction;
	DateTimeType currentDate;
	
	
	
	TimSecondsToDateTime (TimGetSeconds (), &currentDate);
	CurrentTotal=0;
	CurrentTotalc=0;
	
DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
	DmDatabaseSize(cardNo,dbID,&MaxRecords,NULL,NULL);
	if(MaxRecords>0){


	if(TypeOfParse==0){
			CurrentTotal=999999999;
			CurrentTotalc=0;
			}
	if(TypeOfParse==1){
			CurrentTotal=-999999999;
			CurrentTotalc=0;
			}
	RecordNum=0;
	if(TypeOfParse==4){
			BalNumber=Scan(2,false,WorkingTransaction.date,0);
			if(BalNumber<0)return;
			RecordNum=BalNumber;
			recHandle = DmGetRecord(MoneyDB, RecordNum);
			if(recHandle){
						if(ptr=MemHandleLock(recHandle)){
							CurrentTransaction=PtrToStruct(ptr);
							MemHandleUnlock(recHandle);
							}
						DmReleaseRecord(MoneyDB, RecordNum, false);
						}
			CurrentTotal=CurrentTransaction.total;
			CurrentTotalc=CurrentTransaction.totalc;
			RecordNum++;
			if(RecordNum>MaxRecords)RecordNum=MaxRecords;
			}
	
	NegativeValue=false;
	MaxRecords=MaxRecords-1;
	
	for(;RecordNum<MaxRecords+1;RecordNum++){
		BusyNoticePerc(RecordNum,MaxRecords,false);
		recHandle = DmGetRecord(MoneyDB, RecordNum);
		if(recHandle)
			{
				DmRecordInfo (MoneyDB, RecordNum, &attr, NULL, NULL);
				RecCatagory = attr & dmRecAttrCategoryMask;
				if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories)){
						ptr=MemHandleLock(recHandle);
						
						CurrentTransaction=PtrToStruct(ptr);
		MemHandleUnlock(recHandle);
		
		if(TypeOfParse==0){
				if(CurrentTransaction.total<CurrentTotal){
										CurrentTotal=CurrentTransaction.total;
										CurrentTotalc=CurrentTransaction.totalc;
										}
				if(CurrentTransaction.total==CurrentTotal)if(CurrentTransaction.totalc<CurrentTotalc){
										CurrentTotal=CurrentTransaction.total;
										CurrentTotalc=CurrentTransaction.totalc;
										}
								}
								
		if(TypeOfParse==1){
				if(CurrentTransaction.total>CurrentTotal){
										CurrentTotal=CurrentTransaction.total;
										CurrentTotalc=CurrentTransaction.totalc;
										}
				if(CurrentTransaction.total==CurrentTotal)if(CurrentTransaction.totalc>CurrentTotalc){
										CurrentTotal=CurrentTransaction.total;
										CurrentTotalc=CurrentTransaction.totalc;
										}
								}
		if(TypeOfParse==2)if(CurrentTransaction.checknum!=0)if((CurrentTransaction.flags & 1)!=1){
										CurrentTotal+=CurrentTransaction.amount;
										CurrentTotalc+=CurrentTransaction.amountc;
										}
		if(TypeOfParse==3)if (DateTypeCmp(CurrentTransaction.date,currentDate,true)<=0){
												CurrentTotal=CurrentTransaction.total;
												CurrentTotalc=CurrentTransaction.totalc;
												}
		if(TypeOfParse==4)if((CurrentTransaction.flags & 1)==1){
											
												Add(CurrentTotal,CurrentTotalc,CurrentTransaction.amount,CurrentTransaction.amountc);
												CurrentTotal=c1;CurrentTotalc=c2;
											
												}
		if(TypeOfParse==5)if (CurrentTransaction.type==SubCategory){
												Add(CurrentTotal,CurrentTotalc,CurrentTransaction.amount,CurrentTransaction.amountc);
												CurrentTotal=c1;CurrentTotalc=c2;
												}
		if(TypeOfParse==6)if(CurrentTransaction.checknum!=0)if((CurrentTransaction.flags & 1)!=1)++CurrentTotal;
		if(TypeOfParse==7)++CurrentTotal;
					
					}
				DmReleaseRecord(MoneyDB, RecordNum, false);
				}
			}
		}
		if ((CurrentTotal==999999999) | (CurrentTotal==-999999999)){CurrentTotal=0;CurrentTotalc=0;}
		
}





static Boolean NoteViewHandleEvent(EventPtr event)
{
	Boolean	handled = false;
	FormPtr	frm;
	FieldPtr fld;
	VoidHand	textH;
	CharPtr textP;
	
	switch (event->eType)
	{
   	case ctlSelectEvent:
	   	if ((event->data.ctlEnter.controlID == noteDoneButton) |
	   			(event->data.ctlEnter.controlID == noteAllDoneButton))
	   		{
					frm = FrmGetActiveForm();
   		fld=GetObjectPtr(noteField);
				textH=FldGetTextHandle(fld);
				textP = MemHandleLock(textH);
				StrCopy(WorkingTransaction.note,textP);
				MemHandleUnlock(textH);
				if(event->data.ctlEnter.controlID == noteAllDoneButton)InsertEvent(ctlSelectEvent,editDoneButton);
				FrmReturnToForm(editForm);
				DrawNote();
				handled = true;
				}
			  break;
  	
  		case frmOpenEvent:
			frm = FrmGetActiveForm ();
			fld=GetObjectPtr(noteField);
			textH = MemHandleNew(400);
			if (textH)
				{
				textP = MemHandleLock(textH);
				StrCopy(textP, WorkingTransaction.note);
				FldSetTextHandle (fld, textH);
				MemHandleUnlock(textH);
				}
		
  			FrmDrawForm(frm);
			FrmSetFocus (frm, FrmGetObjectIndex (frm, noteField));
			handled = true;
			break;
			
		case frmCloseEvent:
  		break;
	}
	return(handled);
}



static Boolean ListViewHandleEvent(EventPtr event)
{
	Boolean	handled = false;
	FormPtr	frm;
	FieldPtr fld;
	VoidHand	textH;
	CharPtr textP;
	Char temp[20];
	Int j;
	UInt cardNo;

	LocalID dbID;
	LocalID appInfoID;
	MoneyAppInfoPtr	appInfoP;
   MoneyAppInfoType DefaultMoneyAppInfo;

	
				
	switch (event->eType)
	{
   	case ctlSelectEvent:
	   	if (event->data.ctlEnter.controlID == listDoneButton)
	   		{
					frm = FrmGetActiveForm();
					
					
					DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
					DmDatabaseInfo(cardNo, dbID, NULL, NULL, NULL, NULL, NULL, 
							NULL, NULL, &appInfoID, NULL, NULL, NULL);
					appInfoP = MemLocalIDToLockedPtr(appInfoID, cardNo);
					DefaultMoneyAppInfo=*appInfoP;
				if(WhichList)for(j=0;j<20;j++){
						
							fld=GetObjectPtr(listField+j);
							textH=FldGetTextHandle(fld);
							textP = MemHandleLock(textH);
							StrCopy(DefaultMoneyAppInfo.typeLabels[j],textP);
							MemHandleUnlock(textH);
							}
				if(!WhichList)for(j=0;j<20;j++){
							fld=GetObjectPtr(listField+j);
							textH=FldGetTextHandle(fld);
							textP = MemHandleLock(textH);
							StrCopy(DefaultMoneyAppInfo.tranLabels[j],textP);
							MemHandleUnlock(textH);
						}
				DmWrite(appInfoP, 0, &DefaultMoneyAppInfo, sizeof(MoneyAppInfoType));
				MemPtrUnlock(appInfoP);
	
			
				FrmReturnToForm(0);
					handled = true;
					}
			  break;
  	
  		case frmOpenEvent:
			frm = FrmGetActiveForm ();
			for(j=0;j<20;j++){
				fld=GetObjectPtr(listField+j);
				if(WhichList)FldSetMaxChars(fld,9);
					else FldSetMaxChars(fld,19);
				textH = MemHandleNew(20);
				if (textH)
					{
					textP = MemHandleLock(textH);
					if(WhichList)GetType(&temp[0], j);
					else GetTran(&temp[0], j);
					StrCopy(textP, temp);
					FldSetTextHandle (fld, textH);
					MemHandleUnlock(textH);
					}
				}
  			FrmDrawForm(frm);
			FrmSetFocus (frm, FrmGetObjectIndex (frm, listField));
			handled = true;
			break;
			
		case frmCloseEvent:
			
   				
  		break;
	}
	return(handled);
}


static void GetTran(CharPtr string, Int i)
{
	MoneyAppInfoPtr	appInfoP;
	LocalID	dbID;
	LocalID appInfoID;
	UInt		cardNo;

		DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
			DmDatabaseInfo(0, dbID, NULL, NULL, NULL, NULL, NULL, NULL, 
			NULL, &appInfoID, NULL, NULL, NULL);
			appInfoP = MemLocalIDToLockedPtr(appInfoID, cardNo);
			StrCopy(string,appInfoP->tranLabels[i]);
  			MemPtrUnlock(appInfoP);
	
 }
 
static void SetTypeList()
{
	MoneyAppInfoPtr	appInfoP;
	LocalID	dbID;
	LocalID appInfoID;
	UInt		cardNo;
	Int i,y;

		DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
			DmDatabaseInfo(0, dbID, NULL, NULL, NULL, NULL, NULL, NULL, 
			NULL, &appInfoID, NULL, NULL, NULL);
			appInfoP = MemLocalIDToLockedPtr(appInfoID, cardNo);
			for(i=0;i<20;i++){
				TypeChoices[i]=appInfoP->typeLabels[i];
				if(StrLen(appInfoP->typeLabels[i])>1)y=i;
				}
			LstSetListChoices(GetObjectPtr(editTypeList),TypeChoices,y+1);
  			LstSetHeight(GetObjectPtr(editTypeList),y+1);
  			for(i=0;i<20;i++){
				DescChoices[i]=appInfoP->tranLabels[i];
				if(StrLen(appInfoP->tranLabels[i])>1)y=i;
				}
			
			LstSetListChoices(GetObjectPtr(editDescList),DescChoices,y+1);
  			LstSetHeight(GetObjectPtr(editDescList),y+1);
  			
  			
  			MemPtrUnlock(appInfoP);
	
 }
 
 
static void Stats(void)
{
	RectangleType rect;
	Int tempCat,i,y,typeOfReport;
	ListPtr lst;
	Char temp[31],temp2[20];

	
	tempCat=CurrentCategory;
	for(y=0;y<25;y++)StrCopy(ListItems[y]," \0");
	y=0;
	lst = GetObjectPtr (reportTypeList);
	typeOfReport=LstGetSelection (lst);

rect.topLeft.x=1;
rect.topLeft.y=35;
rect.extent.x=159;
rect.extent.y=106;

WinEraseRectangle(&rect,0);
WinDrawChars("Calculating...",14,60,60);
rect.topLeft.x=0;
rect.topLeft.y=31;
rect.extent.x=160;
rect.extent.y=3;

if(typeOfReport==0)for(i=0;i<15;++i){
WinEraseRectangle(&rect,0);
	
	CategoryGetName(MoneyDB,i,&temp[0]);
	if(StrLen(temp)>0){
			CurrentCategory=i;
			Recalculate=true;
			Scan(3,false,WorkingTransaction.date,0);
			ConvertAmount(temp2,CurrentTotal,CurrentTotalc,true,true);
			while(StrLen(temp)<20)StrCat(temp,".");
			StrCat(temp,temp2);
			StrCopy(ListItems[y],temp);y++;
			}
	}

if(typeOfReport!=6)if(typeOfReport>0)for(i=0;i<15;++i){
	WinEraseRectangle(&rect,0);
	CategoryGetName(MoneyDB,i,&temp[0]);
	if(StrLen(temp)>0){
			CurrentCategory=i;
			Parse(typeOfReport-1,0);
			if(typeOfReport<7)ConvertAmount(temp2,CurrentTotal,CurrentTotalc,true,true); else StrIToA(temp2,CurrentTotal);
			while(StrLen(temp)<20)StrCat(temp,".");
			StrCopy(ListItems[y],StrCat(temp,temp2));y++;
			Recalculate=true;
			}
	}

if(typeOfReport==6)for(i=0;i<20;++i){
				WinEraseRectangle(&rect,0);
				GetType(&temp[0],i);
				if(StrLen(temp)>0){
				Parse(typeOfReport-1,i);
				ConvertAmount(temp2,CurrentTotal,CurrentTotalc,true,true);
				if((CurrentTotal!=0) | (CurrentTotalc!=0)){
							while(StrLen(temp)<20)StrCat(temp,".");
							StrCopy(ListItems[y],StrCat(temp,temp2));
							y++;}
				}
			Recalculate=true;
			}
rect.topLeft.x=1;
rect.topLeft.y=25;
rect.extent.x=159;
rect.extent.y=116;

WinEraseRectangle(&rect,0);

for(i=0;i<y;i++)ListItemPointers[i]=ListItems[i];
lst=GetObjectPtr(reportOutputList);
LstSetListChoices(lst,ListItemPointers,y);
if(y<10)LstSetHeight(lst,y); else LstSetHeight(lst,9);

FrmDrawForm(FrmGetActiveForm());
CurrentCategory=tempCat;
}

static Boolean ReportViewHandleEvent(EventPtr event)
{
	Boolean	handled = false;
	FormPtr	frm;
	Char temp[25];

	switch (event->eType)
	{
   	case popSelectEvent:
	   		
			if (event->data.ctlEnter.controlID == reportTypeTrigger)
				{
				Stats();
				StrCopy(temp,LstGetSelectionText( GetObjectPtr (reportTypeList),LstGetSelection(GetObjectPtr (reportTypeList))));
				WinDrawChars(temp,StrLen(temp),10,25);
				handled = true;
				}
		case ctlSelectEvent:
	   	if (event->data.ctlEnter.controlID == reportGenerateButton)
	   		{
				Stats();
				handled = true;
				}
			if (event->data.ctlEnter.controlID == reportDoneButton)
	   		{
	   		Recalculate=true;
				FrmGotoForm(mainForm);
				handled = true;
				}
			else if (event->data.ctlEnter.controlID == editCategoryTrigger)
				{
				
				EditViewSelectCategory ();
				handled = true;
				}
			  break;
  	

  		case frmOpenEvent:
  			
  			frm = FrmGetActiveForm ();
  			
			FrmDrawForm(frm);
			handled = true;
			break;
		
		case frmCloseEvent:
  		
		break;
	}
	return(handled);
}




static Boolean SettingsViewHandleEvent(EventPtr event)
{
	FormPtr	frm;
	ListPtr	lst;
	Int		temp=0;
	Boolean	handled = false;
	ControlPtr	ctl;
	Byte TensPref,UnitsPref,AutoBox;
	VoidHand	textH;
	CharPtr  textP;
	FieldPtr	fld;
	Char tempC[10];
	


	switch (event->eType)
	{
   	case ctlSelectEvent:
	   	if (event->data.ctlEnter.controlID == settingsDoneButton)
	   		{
			TensPref=DisplayPref & 240;
			UnitsPref=DisplayPref & 7;
			AutoBox=DisplayPref & 8;
			if(CtlGetValue(GetObjectPtr(settingsAutoBox))==1)AutoBox=8; else AutoBox=0;
			if(CtlGetValue(GetObjectPtr(settingsLockBox))==1)PrefFlags|=1; else PrefFlags&=254;
			if(CtlGetValue(GetObjectPtr(settingsTotalBox))==0)PrefFlags|=2; else PrefFlags&=253;
			if(CtlGetValue(GetObjectPtr(settingsShowCalcBox))==0)PrefFlags|=4; else PrefFlags&=251;
			lst = GetObjectPtr (settingsCheckList);
			UnitsPref=LstGetSelection (lst);
			lst = GetObjectPtr (settingsAmountList);
			temp=LstGetSelection (lst);
			
			switch (temp){
			case 0:
				TensPref=16;
			break;
			case 1:
				TensPref=32;
			break;
			case 2:
				TensPref=64;
			break;
			case 3:
				TensPref=128;
			break;
			}
			StrCopy(tempC,"90");
			DisplayPref=TensPref | UnitsPref | AutoBox;
			fld=GetObjectPtr(settingsReplField);
			if(FldGetTextLength(fld)>0){textH=FldGetTextHandle(fld);
			textP = MemHandleLock(textH);
			StrCopy(tempC,textP);
			MemHandleUnlock(textH);}
			RepeatBound=StrAToI(tempC);
			
			fld=GetObjectPtr(settingsCurrencyField);
			if(FldGetTextLength(fld)>0){textH=FldGetTextHandle(fld);
			textP = MemHandleLock(textH);
			StrCopy(tempC,textP);
			DollarSign=tempC[0];
			MemHandleUnlock(textH);}
			
			
			FrmGotoForm(mainForm);
			Recalculate=true;
				handled = true;
				}

	   break;
  	
  		case frmOpenEvent:
  			TensPref=DisplayPref & 240;
			UnitsPref=DisplayPref & 7;
			AutoBox=DisplayPref & 8;
			frm = FrmGetActiveForm();
  			ctl = GetObjectPtr (settingsCheckTrigger);

  			lst = GetObjectPtr (settingsCheckList);
						
			if(UnitsPref==0){
						LstSetSelection (lst, 0);
						CategorySetTriggerLabel (ctl, "9999: Desc");
						}
			if(UnitsPref==1){
						LstSetSelection (lst, 1);
						CategorySetTriggerLabel (ctl, "Desc: 9999");
						}
			if(UnitsPref==2){
						LstSetSelection (lst, 2);
						CategorySetTriggerLabel (ctl, "Desc");
						}
			ctl = GetObjectPtr (settingsAmountTrigger);
			lst = GetObjectPtr (settingsAmountList);
			
			if (TensPref & 16){
						LstSetSelection (lst, 0);
						CategorySetTriggerLabel (ctl, "$-999");}
			if (TensPref & 32){
						LstSetSelection (lst, 1);
						CategorySetTriggerLabel (ctl, "$-999.99"); }
			if (TensPref & 64){
						LstSetSelection (lst, 2);
						CategorySetTriggerLabel (ctl, "-999.99"); }
			if (TensPref & 128){
						LstSetSelection (lst, 3);
						CategorySetTriggerLabel (ctl,"-999"); }
			if(AutoBox==8)CtlSetValue(GetObjectPtr(settingsAutoBox), 1); else 
			CtlSetValue(GetObjectPtr(settingsAutoBox), 0);
			if(PrefFlags & 1)CtlSetValue(GetObjectPtr(settingsLockBox), 1); else 
			CtlSetValue(GetObjectPtr(settingsLockBox), 0);
			if((PrefFlags & 2)==2)CtlSetValue(GetObjectPtr(settingsTotalBox), 0); else 
			CtlSetValue(GetObjectPtr(settingsTotalBox), 1);
			if((PrefFlags & 4)==4)CtlSetValue(GetObjectPtr(settingsShowCalcBox), 0); else 
			CtlSetValue(GetObjectPtr(settingsShowCalcBox), 1);
			
			fld=GetObjectPtr(settingsReplField);
			textH = MemHandleNew(7);
			if (textH)
				{
				textP = MemHandleLock(textH);
				StrIToA(tempC, RepeatBound);
				StrCopy(textP,tempC);
				FldSetTextHandle (fld, textH);
				MemHandleUnlock(textH);
				}
			textH = MemHandleNew(2);
			fld=GetObjectPtr(settingsCurrencyField);
			if (textH)
				{
				textP = MemHandleLock(textH);
				tempC[0]=DollarSign;
				tempC[1]='\0';
				StrCopy(textP,tempC);
				FldSetTextHandle (fld, textH);
				MemHandleUnlock(textH);
				}
			
			FrmDrawForm(frm);
			handled = true;
			break;
			
  		case frmCloseEvent:
  			
				
  			break;
	}
	return(handled);
}



static void MainViewUpdateScrollers (FormPtr frm, Int bottomRecord)
{
	Int upIndex;
	Int downIndex;
	Word recordNum;
	Boolean scrollableUp;
	Boolean scrollableDown;
	
	
	recordNum = TopVisibleRecord;
	scrollableUp = !DmSeekRecordInCategory (MoneyDB, &recordNum, 1, 
		dmSeekBackward, CurrentCategory);
	recordNum = bottomRecord;
	scrollableDown = !DmSeekRecordInCategory (MoneyDB, &recordNum, 1, 
		dmSeekForward, CurrentCategory); 
	upIndex = FrmGetObjectIndex (frm, mainScrollUpButton);
	downIndex = FrmGetObjectIndex (frm, mainScrollDownButton);
	FrmUpdateScrollers (frm, upIndex, downIndex, scrollableUp, scrollableDown);
}


static void MainViewDrawRecordInBounds(TransactionType * Transaction,	RectanglePtr bounds, Boolean Searching)
{
	Int			textLen, width;
	Boolean		fits;
	FontID 		currFont;
	Char			temp[30],temp2[30];
	Byte			TensPref,UnitsPref;
	currFont = FntSetFont (stdFont);
	StrCopy(temp,Transaction->description);
	if(Searching==false){
		if(Transaction->checknum!=0)
				{
					TensPref=DisplayPref & 240;
					UnitsPref=DisplayPref & 7;
				   
					if (UnitsPref==0){
						StrIToA(temp,Transaction->checknum);
						StrCat(temp,":");
						StrCat(temp,Transaction->description);
						}
					else 
					if(UnitsPref==1){
						StrCopy(temp,Transaction->description);
						StrIToA(temp2,Transaction->checknum);
						StrCat(temp,":\0");
						StrCat(temp,temp2);
						}
						
				}
	
	if(Transaction->repeat!=0){
			StrCopy(temp2,temp);
			StrCopy(temp,"|\0");
			StrCat(temp,temp2);
			}
	if((Transaction->flags & 1 )==1){
			StrCopy(temp2,temp);
			StrCopy(temp,"(\0");
			StrCat(temp,temp2);
			StrCat(temp,")\0");
			}
		}
	// Determine the length of text that will fit within the bounds.
	width = bounds->extent.x - 2;
	textLen = StrLen(temp);
	FntCharsInWidth(temp, &width, &textLen, &fits);
	
	// Now draw the text from the record.
	WinDrawChars(temp, textLen, bounds->topLeft.x, bounds->topLeft.y);
	// Restore the font.
	FntSetFont (currFont);
}

static void MainViewDrawDateInBounds(	RectanglePtr bounds)
{
	Int			textLen, width;
	Boolean		fits;
	Char dateStr [dateStringLength+1];
	Word len;
	FormPtr frm;
	SystemPreferencesType sysPrefs;
	DateTimeType tempDate;
	 FntSetFont (stdFont);
	if((WorkingTransaction.date.month!=1) | (WorkingTransaction.date.day!=1)
	| (WorkingTransaction.date.year!=1)){
	// Get today's date.
	TimSecondsToDateTime (TimGetSeconds (), &tempDate);
	tempDate.hour=23;
	tempDate.minute=59;
	if (DateTypeCmp(tempDate,WorkingTransaction.date,false)>=0)WinDrawRectangle(bounds,0);// Now draw the text from the record.
	PrefGetPreferences (&sysPrefs);
	
	frm = FrmGetActiveForm ();
	DateToAscii (WorkingTransaction.date.month, 
				 		 WorkingTransaction.date.day, 
				 		 WorkingTransaction.date.year, 
				 		 sysPrefs.dateFormat, &dateStr[0]);
	if((sysPrefs.dateFormat==dfYMDWithSlashes) |
	   (sysPrefs.dateFormat==dfYMDWithDots) |
	   (sysPrefs.dateFormat==dfYMDWithDashes))for(len=3;len<dateStringLength;len++)dateStr[len-3]=dateStr[len];
	
	if((sysPrefs.dateFormat==dfMDYWithSlashes) |
		(sysPrefs.dateFormat==dfDMYWithSlashes) |
		(sysPrefs.dateFormat==dfDMYWithDots) |
		(sysPrefs.dateFormat==dfDMYWithDashes))for(len=StrLen(dateStr)-3;len<dateStringLength;len++)dateStr[len]=0;
	
	if (DateTypeCmp(tempDate,WorkingTransaction.date,false)==0)StrCopy(dateStr,"today");
		len = StrLen (dateStr);

	// Determine the length of text that will fit within the bounds.
	width = bounds->extent.x - 2;
	textLen = StrLen(dateStr);
	FntCharsInWidth(dateStr, &width, &textLen, &fits);
	
	if (DateTypeCmp(tempDate,WorkingTransaction.date,false)<0)
			WinDrawChars(dateStr, textLen, bounds->topLeft.x, bounds->topLeft.y);
	if (DateTypeCmp(tempDate,WorkingTransaction.date,false)>=0)
			WinDrawInvertedChars(dateStr, textLen, bounds->topLeft.x, bounds->topLeft.y);
		 FntSetFont (stdFont);
	}
}


static void MainViewDrawAmountInBounds(Long amount, Int cents,	RectanglePtr bounds)
{
	Int			textLen, width;
	short 	Offset;
	Boolean		fits;
	FontID 		currFont;
	Char temp[20];
	FormPtr frm;
	
	frm = FrmGetActiveForm ();
	ConvertAmount(temp,amount,cents,true,false);
	currFont = FntSetFont (stdFont);
				
	// Determine the length of text that will fit within the bounds.
	width = bounds->extent.x - 2;
	textLen = StrLen(temp);
	FntCharsInWidth(temp, &width, &textLen, &fits);
	Offset=FntCharsWidth(temp,textLen);
	Offset=bounds->extent.x - Offset+bounds->topLeft.x;
	// Now draw the text from the record.
	WinDrawChars(temp, textLen, Offset, bounds->topLeft.y);
	
	// Restore the font.
	FntSetFont (currFont);
}


static Int GetAmountWidth(Long amount, Int cents)
{
	Int			textLen, width;
	Char temp[20];
	FormPtr frm;
	
	frm = FrmGetActiveForm ();
	ConvertAmount(temp,amount,cents,true,false);
		textLen = StrLen(temp);
	width=FntCharsWidth(temp,textLen);
		return(width);
}



/***********************************************************************
 *
 * FUNCTION:		MainViewDrawRecord
 *
 * DESCRIPTION:	P12. Draw an item in the main form's table.  This 
 *						routine is called from the table object and must match
 *						the parameters that the table object passes.  The routine
 *						MainViewLoadRecords sets the table object to call this
 *						routine.  The table object calls it once for every table 
 *						cell needing drawing.
 *
 * PARAMETERS:		tableP - table in which to draw the record
 *						row - row of the record to change
 *						column - column of the record to change
 *						bounds - bounds in which to draw the record
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void MainViewDrawRecord(VoidPtr tableP, Word row, Word column, 
	RectanglePtr bounds)
{
	Handle		recHandle;
	UInt			recordNum = 0;
	TransactionTypePtr ptr;

	// Get the record number that corresponds to the table item to draw.
	// The record number is stored in the "intValue" field of the item.
	recordNum = TblGetItemInt (tableP, row, column);

	// Retrieve the record from the database and lock it down.
	recHandle = DmGetRecord(MoneyDB, recordNum);
	ptr = MemHandleLock(recHandle);

	// P14. Draw the record
	WorkingTransaction=PtrToStruct(ptr);
	MainViewDrawRecordInBounds(&WorkingTransaction, bounds,false);
		
	// Unlock the handle to the record.
	MemHandleUnlock(recHandle);
	
	// Release the record, not dirty.
	DmReleaseRecord(MoneyDB, recordNum, false);
}

static void MainViewDrawDate(VoidPtr tableP, Word row, Word column, 
	RectanglePtr bounds)
{
	Handle		recHandle;
	UInt			recordNum = 0;
	TransactionTypePtr ptr;

	// Get the record number that corresponds to the table item to draw.
	// The record number is stored in the "intValue" field of the item.
	recordNum = TblGetItemInt (tableP, row, column);

	// Retrieve the record from the database and lock it down.
	recHandle = DmGetRecord(MoneyDB, recordNum);
	
	ptr=MemHandleLock(recHandle);
		WorkingTransaction.date=ptr->date; // get the date
		MemHandleUnlock(recHandle);
		
	// P14. Draw the record
	MainViewDrawDateInBounds(bounds);
	
	// Unlock the handle to the record.

	
	// Release the record, not dirty.
	DmReleaseRecord(MoneyDB, recordNum, false);
}

static void MainViewDrawAmount(VoidPtr tableP, Word row, Word column, 
	RectanglePtr bounds)
{
	Handle		recHandle;
	UInt			recordNum = 0;
	Long			amount;
	Int			cents;
	TransactionTypePtr ptr;

	// Get the record number that corresponds to the table item to draw.
	// The record number is stored in the "intValue" field of the item.
	recordNum = TblGetItemInt (tableP, row, column);

	// Retrieve the record from the database and lock it down.
	recHandle = DmGetRecord(MoneyDB, recordNum);
	
	ptr=MemHandleLock(recHandle);
		amount=ptr->amount; // get the date
		cents=ptr->amountc; // get the date
		MemHandleUnlock(recHandle);
		
	// P14. Draw the record
	MainViewDrawAmountInBounds(amount,cents,bounds);
	
	// Unlock the handle to the record.

	
	// Release the record, not dirty.
	DmReleaseRecord(MoneyDB, recordNum, false);
}

static void MainViewDrawTotal(VoidPtr tableP, Word row, Word column, 
	RectanglePtr bounds)
{
	Handle		recHandle;
	UInt			recordNum = 0;
	Long			amount;
	Int cents;
	TransactionTypePtr ptr;
Boolean hasNote;
	

	// Get the record number that corresponds to the table item to draw.
	// The record number is stored in the "intValue" field of the item.
	recordNum = TblGetItemInt (tableP, row, column);

	// Retrieve the record from the database and lock it down.
	recHandle = DmGetRecord(MoneyDB, recordNum);
		hasNote=false;
		ptr=MemHandleLock(recHandle);
		amount=ptr->total; // get the date
		cents=ptr->totalc; // get the date
		if(StrLen(ptr->note)>0)hasNote=true;
		MemHandleUnlock(recHandle);
		
	// P14. Draw the record
	if((PrefFlags & 2)==0)MainViewDrawAmountInBounds(amount,cents,bounds);
	DmReleaseRecord(MoneyDB, recordNum, false);
}

static void MainViewDrawNote(VoidPtr tableP, Word row, Word column, 
	RectanglePtr bounds)
{

	static Handle					ObjectBitmapHandle;
	static BitmapPtr				ObjectBitmapPtr;
	Handle		recHandle;
	UInt			recordNum = 0;
	TransactionTypePtr ptr;
	Boolean hasNote;
	

	// Get the record number that corresponds to the table item to draw.
	// The record number is stored in the "intValue" field of the item.
	recordNum = TblGetItemInt (tableP, row, column);

	// Retrieve the record from the database and lock it down.
	recHandle = DmGetRecord(MoneyDB, recordNum);
		hasNote=false;
		ptr=MemHandleLock(recHandle);
		if(StrLen(ptr->note)>0)hasNote=true;
		MemHandleUnlock(recHandle);
		if(hasNote){
		ObjectBitmapHandle= DmGetResource( bitmapRsc, 1608);
		ObjectBitmapPtr = MemHandleLock(ObjectBitmapHandle);
		WinDrawBitmap(ObjectBitmapPtr,bounds->topLeft.x, bounds->topLeft.y+2);
		MemPtrUnlock(ObjectBitmapPtr);
		DmReleaseResource(ObjectBitmapHandle);
		}
	DmReleaseRecord(MoneyDB, recordNum, false);
}


/***********************************************************************
 *
 * FUNCTION:    MainViewLoadTable
 *
 * DESCRIPTION: P12. Loads the database records into the main table.
 *
 * PARAMETERS:  frm - form containing table to load
 *					 recordNum - index of the first record to display.
 *
 * RETURNED:    nothing
 *
 ***********************************************************************/
static void MainViewLoadTable (FormPtr frm, UInt recordNum)
{
	Word			row;
	Word			lastRecordNum;
	Word			numRows;
	TablePtr 	tableP;
	VoidHand		recordH;

	
	tableP = FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, mainTable));

	// For each row in the table, store the record number in the 
	// table item that will display the record.  
	numRows = TblGetNumberOfRows (tableP);
	for (row = 0; row < numRows; row++, recordNum++)
		{		
		// Get the next record in the current category.
		recordH = DmQueryNextInCategory (MoneyDB, &recordNum, 
			CurrentCategory);
		
		// If the record was found, store the record number in the table item,
		// otherwise set the table row unusable.
		if (recordH)
			{
			// Set customTableItem to indicate that we want to be called
			// to draw the record.  The callback set in MainViewLoadRecords
			// will be called to draw the record.
			TblSetItemStyle (tableP, row, 0, customTableItem);
			TblSetItemInt (tableP, row, 0, recordNum);
			TblSetRowUsable (tableP, row, true);
			
			TblSetItemStyle (tableP, row, 1, customTableItem);
			TblSetItemInt (tableP, row, 1, recordNum);
			TblSetRowUsable (tableP, row, true);
			
			TblSetItemStyle (tableP, row, 2, customTableItem);
			TblSetItemInt (tableP, row, 2, recordNum);
			TblSetRowUsable (tableP, row, true);
			
			TblSetItemStyle (tableP, row, 3, customTableItem);
			TblSetItemInt (tableP, row, 3, recordNum);
			TblSetRowUsable (tableP, row, true);
			
			TblSetItemStyle (tableP, row, 4, customTableItem);
			TblSetItemInt (tableP, row, 4, recordNum);
			TblSetRowUsable (tableP, row, true);
			
			lastRecordNum = recordNum;
			}
		else
			{
			// Sometimes there are more table rows than records.
			// If this happens mark those unused table rows as
			// not usable.
			TblSetRowUsable (tableP, row, false);
			}

		// Mark the row invalid so that it will draw when we call the 
		// draw routine.
		TblMarkRowInvalid (tableP, row);

		}

	   		
	   				TblSetColumnWidth(tableP,1,122-AmountWidth-TotalWidth);
	   				TblSetColumnWidth(tableP,2,AmountWidth);
	   				TblSetColumnWidth(tableP,3,TotalWidth);
	   			
	   		
			
	// P13. Update the scroll arrows.
	MainViewUpdateScrollers (frm, lastRecordNum);
}


/***********************************************************************
 *
 * FUNCTION:		MainViewLoadRecords
 *
 * DESCRIPTION:	P12. Loads the table object with records.
 *
 * PARAMETERS:		frm - form containing table to load
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void MainViewLoadRecords(FormPtr frm)
{
	TablePtr 	tableP;
	Word			recordNum;
	Word			rowsInTable;

	
	// Get the table and it's number of rows
	tableP = FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, mainTable));
	rowsInTable = TblGetNumberOfRows (tableP);

	// Before we load the table with records we should do any positioning
	// of the table now.
	
	// If there is a current record is it visible?
	if (CurrentRecord != noRecordSelected)
		{
		// Is the current record before the first visible record?
		if (TopVisibleRecord > CurrentRecord)
			{
			// Make CurrentRecord the top record displayed.
			TopVisibleRecord = CurrentRecord;
			}
		
		// Is the current record after the last visible record?
		else
			{
			// Find the record displayed at the bottom of the table.
			// If the record is before the current record then the 
			// current record isn't displayed.  In that case make
			// the CurrentRecord the first record displayed in the table.
			recordNum = TopVisibleRecord;
			DmSeekRecordInCategory (MoneyDB, &recordNum, rowsInTable-1,
				dmSeekForward, CurrentCategory);
			if (recordNum < CurrentRecord)
				TopVisibleRecord = CurrentRecord;
			}
		}

	
	// Try to show a full display of records.  Starting at the last
	// record and working backwards, find the record displayed at the 
	// top of the table.  If the record is before the TopVisibleRecord
	// then TopVisibleRecord is set too far down the list of records.
	// Set TopVisibleRecord to the record one screen full from the end.
	recordNum = dmMaxRecordIndex;
	DmSeekRecordInCategory (MoneyDB, &recordNum, (rowsInTable-1),
		dmSeekBackward, CurrentCategory);
	TopVisibleRecord = min (TopVisibleRecord, recordNum);


	// Now that the table is in position load the records.
	MainViewLoadTable (frm, TopVisibleRecord);

	// Set the callback routine that will draw the records.
	TblSetCustomDrawProcedure (tableP, 4, MainViewDrawNote);
	TblSetCustomDrawProcedure (tableP, 3, MainViewDrawTotal);
	TblSetCustomDrawProcedure (tableP, 2, MainViewDrawAmount);
	TblSetCustomDrawProcedure (tableP, 1, MainViewDrawRecord);
	TblSetCustomDrawProcedure (tableP, 0, MainViewDrawDate);

	// Set the column usable so that it draws and accepts user input.
	TblSetColumnUsable (tableP, 4, true);	
	TblSetColumnUsable (tableP, 3, true);	
	TblSetColumnUsable (tableP, 2, true);	
TblSetColumnUsable (tableP, 1, true);	
TblSetColumnUsable (tableP, 0, true);	
}


static void DoStatLine(Boolean Clear)
{

RectangleType rect;
	Char temp[20];
			rect.topLeft.x=35;
		rect.topLeft.y=147;
		rect.extent.x=111;
		rect.extent.y=12;

	WinEraseRectangle(&rect,0);
	if(Clear==false){
		ConvertAmount(temp,todaysTotal,todaysTotalc,true,true);
		FntSetFont (stdFont);
	if(MainStatusChoise>3)MainStatusChoise=0;
	switch(MainStatusChoise)
		{
		case 0:
			WinDrawChars("Balance.............",20,35,147);
			break;
		case 1:
			WinDrawChars("Ending Balance......",20,35,147);
			break;
		case 2:
			WinDrawChars("Min Balance.........",20,35,147);
			break;
		case 3:
			WinDrawChars("Max Balance.........",20,35,147);
			break;
		}
		
		WinDrawChars(temp,StrLen(temp),100,147);
		}
		
	
		
}




	
		



static void ClearEm(void)
{
	ULong RecordNum,MaxRecords;
	UInt cardNo;
	Long	CurrentTotal,CurrentTotalc;
	LocalID dbID;
	UInt RecCatagory,attr;
	Int		BalanceTransactionNumber;
	VoidHand	recHandle;
	TransactionTypePtr	ptr;
	TransactionType	CurrentTransaction;
	Boolean DeleteItLoc=false;
	CurrentTotal=0;
	CurrentTotalc=0;
	
	BalanceTransactionNumber=Scan(2,false,WorkingTransaction.date,0);
	if(BalanceTransactionNumber<0)return;
	
	DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
	DmDatabaseSize(cardNo,dbID,&MaxRecords,NULL,NULL);
	
	
	if(MaxRecords>1){
	
	recHandle = DmGetRecord(MoneyDB, BalanceTransactionNumber); // Get balance
	ptr=MemHandleLock(recHandle);
	CurrentTotal=ptr->amount;
	CurrentTotalc=ptr->amountc;
	CurrentTransaction.flags=ptr->flags;
	MemHandleUnlock(recHandle);
	DmReleaseRecord(MoneyDB,  BalanceTransactionNumber, false);
	
			MaxRecords=MaxRecords-1;
	BusyNotice("Balancing...");
	for(RecordNum=0;RecordNum<=MaxRecords;RecordNum++){
	BusyNoticePerc(RecordNum,MaxRecords,true);

		recHandle = DmGetRecord(MoneyDB, RecordNum);
		if(recHandle)
			{	DmRecordInfo (MoneyDB, RecordNum, &attr, NULL, NULL);
				RecCatagory = attr & dmRecAttrCategoryMask;
				DeleteItLoc=false;
				ptr=MemHandleLock(recHandle);
						CurrentTransaction=PtrToStruct(ptr);
						MemHandleUnlock(recHandle);
				if ((CurrentCategory == RecCatagory) | (CurrentCategory == dmAllCategories))if((CurrentTransaction.flags & 1)==1)
						if(BalanceTransactionNumber!=RecordNum)
											{
											Add(CurrentTotal,CurrentTotalc,CurrentTransaction.amount,CurrentTransaction.amountc);
											CurrentTotal=c1;
											CurrentTotalc=c2;
											DeleteItLoc=true;
											}
						DmReleaseRecord(MoneyDB, RecordNum, false);
			if(DeleteItLoc==true){
									DmRemoveRecord(MoneyDB, RecordNum);
									RecordNum=0;
									MaxRecords--;
									Recalculate=true;
									}
			}
		

	}
		recHandle = DmGetRecord(MoneyDB, BalanceTransactionNumber);
		ptr=MemHandleLock(recHandle);
		WorkingTransaction=PtrToStruct(ptr);
		WorkingTransaction.amount=CurrentTotal;
		WorkingTransaction.amountc=CurrentTotalc;
		DmWrite(ptr, 0, &WorkingTransaction, sizeof(TransactionType)-400+StrLen(WorkingTransaction.note));
		MemHandleUnlock(recHandle);
		DmReleaseRecord(MoneyDB, BalanceTransactionNumber,true);
		CurrentRecord=BalanceTransactionNumber;
	
	Recalculate=true;
	Scan(3,true,WorkingTransaction.date,0);
	FrmCloseAllForms();
	FrmGotoForm(mainForm);
	}
}

static void Recur(Boolean DisplayNotice)
{
	ULong RecordNum,MaxRecords;
	UInt cardNo,attr;
	LocalID dbID;
	VoidHand	recHandle;
	TransactionTypePtr	ptr;
	Word repeatThis;
	Word recurse=1;

	if(DisplayNotice)BusyNotice("Entering Recurring");
	DmOpenDatabaseInfo(MoneyDB, &dbID, NULL, NULL, &cardNo, NULL);
	while(recurse==1){
	recurse=0;
	DmDatabaseSize(cardNo,dbID,&MaxRecords,NULL,NULL);
	if(MaxRecords>1){
	MaxRecords=MaxRecords-1;
	for(RecordNum=0;RecordNum<=MaxRecords;RecordNum++){
	if(DisplayNotice)BusyNoticePerc(RecordNum,MaxRecords,DisplayNotice);
		DmRecordInfo (MoneyDB, RecordNum, &attr, NULL, NULL);
		recHandle = DmGetRecord(MoneyDB, RecordNum);
		repeatThis=0;
		if(recHandle)
			{
						ptr=MemHandleLock(recHandle);
						repeatThis=ptr->repeat;
						if(repeatThis!=0){
						
								WorkingTransaction=PtrToStruct(ptr);
		WorkingTransaction.repeat=0;
		DmWrite(ptr, 0, &WorkingTransaction, sizeof(TransactionType)-400+StrLen(WorkingTransaction.note));
								}
						MemHandleUnlock(recHandle);
						if(repeatThis>0)DmReleaseRecord(MoneyDB, RecordNum, true);
						else DmReleaseRecord(MoneyDB, RecordNum, false);
						if (repeatThis>0)if(DupeIt(repeatThis,RecordNum,attr)>0){
								Resort=true;Recalculate=true;
								recurse=1;RecordNum=0;}
								
			
				}
			}
	  }
	  }
}


/***********************************************************************
 *
 * FUNCTION:    MainViewSelectCategory
 *
 * DESCRIPTION: P11. This routine handles selection, creation and deletion of
 *              categories for the Main View.  
 *
 * PARAMETERS:  nothing
 *
 * RETURNED:    The index of the new category.
 *
 *              The following global variables are modified:
 *							CurrentCategory
 *							CategoryName
 *
 ***********************************************************************/
static Int MainViewSelectCategory (void)
{
	FormPtr frm;
	Word category;
	Boolean categoryEdited;
	TablePtr tableP;

	
	// Process the category popup list.  
	category = CurrentCategory;

	frm = FrmGetActiveForm();
	categoryEdited = CategorySelect (MoneyDB, frm, mainCategoryTrigger,
					  mainCategoryList, true, &category, CategoryName);
	
	if (categoryEdited || (category != CurrentCategory))
		{
		CurrentCategory = category;
		// P16. Count the records later when needed to display.
		MemosInCategory = memosInCategoryUnknown;
		Recalculate=true;
		Scan(3,true,WorkingTransaction.date,0);
		MainViewLoadRecords (frm);
		tableP = GetObjectPtr (mainTable);
		TblEraseTable (tableP);
		TblDrawTable (tableP);
		}

	return (category);
}


/***********************************************************************
 *
 * FUNCTION:    MainViewScroll
 *
 * DESCRIPTION: P13. This routine scrolls the list of memo titles
 *              in the direction specified.
 *
 *					 Scrolling up stops at the first record visible.  
 *					 Because of categories and private records the first
 *					 record visible isn't neccessarily record 0.
 *
 *					 Scrolling down stops when less than a full table of
 *					 records can be displayed.  To enfore this when the 
 *					 table is scrolled down, we check if at the new 
 *					 position there are enough records visible to fill
 *					 the table.  If not we find the last records visible
 *					 by working backwards from the end.
 *
 * PARAMETERS:  direction - up or dowm
 *					 oneLine - true scrolls one line, false scrolls one page
 *
 * RETURNED:    nothing
 *
 ***********************************************************************/
static void MainViewScroll (DirectionType direction, Boolean oneLine)
{
	TablePtr tableP;
	Int 		rowsInTable;
	UInt		newTopVisibleRecord;
	FormPtr	frmP;

	tableP = GetObjectPtr (mainTable);
	rowsInTable = TblGetNumberOfRows (tableP);
	newTopVisibleRecord = TopVisibleRecord;
	CurrentRecord = noRecordSelected;

	// Scroll the table down.
	if (direction == down)
		{
		// Scroll down a single line.
		if (oneLine)
			{
			DmSeekRecordInCategory (MoneyDB, &newTopVisibleRecord, 1, 
				dmSeekForward, CurrentCategory);
			}

		// Scroll down a page (less one row).
		else
			{
			// Try going forward one page
			if (DmSeekRecordInCategory (MoneyDB, &newTopVisibleRecord, 
					rowsInTable - 1, dmSeekForward, CurrentCategory))
				{
				// Try going backwards one page from the last record
				newTopVisibleRecord = dmMaxRecordIndex;
				DmSeekRecordInCategory (MoneyDB, &newTopVisibleRecord, 
					rowsInTable - 1, dmSeekBackward, CurrentCategory);
				}
			}
		}



	// Scroll the table up.
	else
		{
		// Scroll up a single line
		if (oneLine)
			{
			DmSeekRecordInCategory (MoneyDB, &newTopVisibleRecord, 1, 
				dmSeekBackward, CurrentCategory);
			}

		// Scroll up a page (less one row).
		else
			{
			if (DmSeekRecordInCategory (MoneyDB, &newTopVisibleRecord, 
				rowsInTable - 1, dmSeekBackward, CurrentCategory))
				{
				// Not enough records to fill one page.  Start with the first record
				newTopVisibleRecord = 0;
				DmSeekRecordInCategory (MoneyDB, &newTopVisibleRecord, 0, 
					dmSeekForward, CurrentCategory);
				}
			}
		}


	// Avoid redraw if no change
	if (TopVisibleRecord != newTopVisibleRecord)
		{
		// The table should be at a different position.  Load the
		// table with new records and redraw it.
		TopVisibleRecord = newTopVisibleRecord;
		frmP = FrmGetActiveForm ();
		MainViewLoadRecords (frmP);
		TblRedrawTable(tableP);
		}
}


/***********************************************************************
 *
 * FUNCTION:		MainViewInit
 *
 * DESCRIPTION:	P7. Initializes the main form and the list object.
 *
 * PARAMETERS:		frm - pointer to the main form.
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void MainViewInit(void)
{
	FormPtr			frm;
	RectangleType rect;
		rect.topLeft.x=0;
		rect.topLeft.y=0;
		rect.extent.x=160;
		rect.extent.y=140;

		



	// Get a pointer to the main form.
	frm = FrmGetActiveForm();
	
	MainViewLoadRecords(frm);

	// P11. Set the label of the category trigger.
	CategoryGetName (MoneyDB, CurrentCategory, CategoryName);
	CategorySetTriggerLabel (GetObjectPtr (mainCategoryTrigger), CategoryName);
	WinEraseRectangle(&rect,0);
	// Draw the form.
	FrmDrawForm(frm);
}


 
static void RunExport()
{
LocalID dbID;
UInt cardNo=0;
DmSearchStateType searchInfo;
Boolean newSearch=true;
	
DmGetNextDatabaseByTypeCreator (newSearch, &searchInfo, 
sysFileTApplication, 'MoEx', true, &cardNo, &dbID);
if(dbID)
SysUIAppSwitch(0,dbID,sysAppLaunchCmdNormalLaunch,NULL);
}

static Boolean MainViewHandleEvent(EventPtr event)
{
	Boolean		handled = false;
	FormPtr		frm;
	Word xx,yy;
	TablePtr tbl;
	UInt recordNum;
	DateTimeType currentDate;
	TimSecondsToDateTime (TimGetSeconds (), &currentDate);
	currentDate.hour=23;
	currentDate.minute=59;
	
	
	switch (event->eType)
		{
   	case ctlSelectEvent:  // A control button was pressed and released.
	   	if (event->data.ctlEnter.controlID == mainNewButton)
	   		{
				// P5. Flag to the edit form that a new record is needed.
				// CurrentRecord = noRecordSelected;
				
				// P6. Create a new database record.
				if (CreateRecord(false))
					{
					// P3. The new button is pressed, go to the edit form.
					FrmGotoForm(editForm);
					}
				handled = true;
				}
			if (event->data.ctlEnter.controlID == mainToggleButton)
	   		{
				MainStatusChoise++;
				if(MainStatusChoise>3)MainStatusChoise=0;
				Recalculate=true;
				Scan(3,false,WorkingTransaction.date,0);
				DoStatLine(false);
				handled = true;
				}
			
			
	   	// P11. If the category trigger is pressed, pop up the category list.
	   	else if (event->data.ctlEnter.controlID == mainCategoryTrigger)
	   		{
				MainViewSelectCategory();
				handled = true;
				}
			break;
  	

   	case ctlRepeatEvent:
	   	if (event->data.ctlRepeat.controlID == mainScrollUpButton)
	   		{
	   		MainViewScroll (up, true);
	   		}
	   	else if (event->data.ctlRepeat.controlID == mainScrollDownButton)
	   		{
	   		MainViewScroll (down, true);
	   		}
	  
			break;


   	case keyDownEvent:
	   	if (event->data.keyDown.chr == pageUpChr)
	   		{
	   		MainViewScroll (up, false);
	   		handled = true;
	   		}
	   	else if (event->data.keyDown.chr == pageDownChr)
	   		{
	   		MainViewScroll (down, false);
	   		handled = true;
	   		}
			break;


  		case tblSelectEvent:  // P12. An entry in the table was selected.
			// Edit the record at the selected table item.
			tbl=event->data.tblSelect.pTable;
			xx=event->data.tblSelect.row;
			yy=event->data.tblSelect.column;
			CurrentRecord = TblGetItemInt (tbl,xx,yy);
			if(yy==4){
						FrmGotoForm(editForm);JumpNote=true;
						}
			else
			if(event->data.tblSelect.column>0)FrmGotoForm(editForm);
			else {
		
					FlipRecord();
					TblMarkRowInvalid(tbl,xx);
					
					TblRedrawTable(tbl);
					TblMarkRowInvalid(tbl,xx);
					}
			
			handled = true;
			break;

  		case frmOpenEvent:	// P3. The form was told to open.
  			// P7. Initialize the main form.
  			SortIt();
  			Scan(3,true,WorkingTransaction.date,0);
  			MainViewInit();
  			DoStatLine(false);
  			FrmSetTitle(FrmGetActiveForm(),MainViewTitlePtr);
  			handled = true;
  			break;
			
			
		case menuEvent:		// P2. A menu item was selected.
			// The get info being the only menu item, display the info form.
			
			// First clear the menu status from the display.
			MenuEraseStatus(0);
			switch (event->data.menu.itemID)
					{
					case 100:
						FrmGotoForm (reportForm);
						handled = true;
						break;
					case 101:
						FrmGotoForm(settingsForm);
						handled = true;
						break;
					case 102:
						if (FrmAlert(mainBalanceAlert) == editDeleteOK)
							ClearEm();
						handled=true;
						break;
					case 103:
						Recur(true);
						Resort=true;
						SortIt();
						FrmGotoForm (mainForm);
						handled=true;
						break;
					case 105:
						WhichList=true;
						FrmPopupForm(listForm);
						handled = true;
						break;
					case 106:
						WhichList=false;
						FrmPopupForm(listForm);
						handled = true;
						break;
					case 108:
						frm = FrmInitForm(infoForm);
						FrmDoDialog(frm);
						FrmDeleteForm(frm);
						handled = true;
						break;
					case 200:
						TopVisibleRecord=0;
						CurrentRecord=0;
						FrmGotoForm (mainForm);
						handled=true;
						break;
					case 201:
						CurrentRecord=99999;
						TopVisibleRecord=99999;
						FrmGotoForm (mainForm);
						handled=true;
						break;
					case 202:
						recordNum=Scan(4,false,currentDate,0);
						SetTop(recordNum);
						FrmGotoForm (mainForm);
						handled=true;
						break;
					case 203:
						ResetDate();
						if(SelectDate()){
						CurrentRecord = Scan(4,false,WorkingTransaction.date,0);
						if (CurrentRecord == noRecordSelected){
							TopVisibleRecord = 0;
							CurrentRecord = noRecordSelected;
							}
							else SetTop(CurrentRecord);
						FrmGotoForm (mainForm);}
						handled=true;
						break;
					case 300:
						RunExport();
						handled=true;
						break;
					}
			handled = true;
			break;
		}
	return(handled);
}


/***********************************************************************
 *
 * FUNCTION:    ApplicationHandleEvent
 *
 * DESCRIPTION: P3. This routine loads a form resource and sets the event handler for the form.
 *
 * PARAMETERS:  event - a pointer to an EventType structure
 *
 * RETURNED:    True if the event has been handled and should not be
 *						passed to a higher level handler.
 *
 ***********************************************************************/
static Boolean ApplicationHandleEvent(EventPtr event)
{
	FormPtr	frm;
	Int		formId;
	Boolean	handled = false;

	if (event->eType == frmLoadEvent)
		{
		// Load the form resource specified in the event then activate the form.
		formId = event->data.frmLoad.formID;
		frm = FrmInitForm(formId);
		FrmSetActiveForm(frm);

		// Set the event handler for the form.  The handler of the currently 
		// active form is called by FrmDispatchEvent each time it receives an event.
		switch (formId)
			{
			case mainForm:
				FrmSetEventHandler(frm, MainViewHandleEvent);
				break;
		
			case editForm:
				FrmSetEventHandler(frm, EditViewHandleEvent);
				break;
		
			case noteForm:
				FrmSetEventHandler(frm, NoteViewHandleEvent);
				break;
		
			case listForm:
				FrmSetEventHandler(frm, ListViewHandleEvent);
				break;
		
			case reportForm:
				FrmSetEventHandler(frm, ReportViewHandleEvent);
				break;
		
			case settingsForm:		// P10.
				FrmSetEventHandler(frm, SettingsViewHandleEvent);
				break;
			}
		handled = true;
		}
	
	return handled;
}

static void StopApplication(void)
{
		
	MoneyPreferenceType prefs;
	FrmCloseAllForms ();
	prefs.topVisibleRecord = TopVisibleRecord;
	prefs.currentRecord = CurrentRecord;
	prefs.currentCategory = CurrentCategory;
	prefs.repeatBound =RepeatBound;
	prefs.displayPref =DisplayPref;
	prefs.dollarSign =DollarSign;
	prefs.version=6;
	prefs.prefflags=PrefFlags;	
	prefs.mainstatuschoise=MainStatusChoise;	
	FplFree();

	if ( DmQueryRecord (MoneyDB, CurrentRecord) != 0)
		{
		DmRecordInfo (MoneyDB, CurrentRecord, NULL, &prefs.currentRecordID, NULL);
		}
	else
		prefs.currentRecordID = noRecordSelectedID;


	PrefSetAppPreferences (MoneyAppType, MoneyVersionNum, &prefs, 
		sizeof (MoneyPreferenceType));


	DmCloseDatabase(MoneyDB);

}





/***********************************************************************
 *
 * FUNCTION:		EventLoop
 *
 * DESCRIPTION:	A simple loop that obtains events from the Event
 *						Manager and passes them on to various applications and
 *						system event handlers before passing them on to
 *						FrmDispatchEvent for default processing.
 *
 * PARAMETERS:		None.
 *
 * RETURNED:		Nothing.
 *
 ***********************************************************************/
static void EventLoop(void)
{
	EventType	event;
	Word			error;
	
	do
		{
		// Get the next available event.
		EvtGetEvent(&event, evtWaitForever);
		
		// Give the system a chance to handle the event.
		if (! SysHandleEvent(&event))

			// P2. Give the menu bar a chance to update and handle the event.	
			if (! MenuHandleEvent(NULL, &event, &error))

				// P3. Give the application a chance to handle the event.
				if (! ApplicationHandleEvent(&event))

					// P3. Let the form object provide default handling of the event.
					FrmDispatchEvent(&event);
		}
	while (event.eType != appStopEvent);
}



/***********************************************************************
 *
 * FUNCTION:		PilotMain
 *
 * DESCRIPTION:	This function is the equivalent of a main() function
 *						under standard C.  It is called by the Emulator to begin
 *						execution of this application.
 *
 * PARAMETERS:		cmd - command specifying how to launch the application.
 *						cmdPBP - parameter block for the command.
 *						launchFlags - flags used to configure the launch.			
 *
 * RETURNED:		Any applicable error codes.
 *
 ***********************************************************************/
DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
Int err;

		if (cmd == sysAppLaunchCmdNormalLaunch)
		{
		err=StartApplication();
		if(err)return(err);
			FrmGotoForm(CurrentView);
				
			// Start the event loop.
			EventLoop();
			
			// P5. Clean up before exiting the applcation.
			StopApplication();
			
		}
		// P14. The system find command uses this to search this application.
	else if (cmd == sysAppLaunchCmdFind)
		{
		Search ((FindParamsPtr)cmdPBP);
		}
	
	
	// P14. If the user wants to goto a record listed in the find dialog
	// it sends the following notification
	else if (cmd == sysAppLaunchCmdGoTo)
		{
		// Check if new global variables are set up.  This occurs when the 
		// system intends for the app to start.
		if (launchFlags & sysAppLaunchFlagNewGlobals) 
			{
			// This occurs when the user wants to see a record in this
			// application's database.  The app must be started and 
			// a view to display the data must be opened.
			if (!StartApplication ())
				{
				GoToRecord ((GoToParamsPtr) cmdPBP, true);
				
				EventLoop ();
				StopApplication ();
				}
			}
		else
			{
			// The app was already running.  Open a form to display the record.
			GoToRecord ((GoToParamsPtr) cmdPBP, false);
			}
		}

	// P14. Launch code sent to running app to save all data.
	// This is neccessary before a find for some applications because
	// some apps do not edit in place and the user might search for
	// data not saved.  Or saving a record might reorder the database.
	// Saving before a find avoids finding a record, saving, resorting,
	// and then displaying a record moved to the position of the found
	// record.
	else if (cmd == sysAppLaunchCmdSaveData)
		{
		FrmSaveAllForms ();
		}
	

	// P17. The database has been synchronized.  Handle any changes
	// in the data (resorting data could be performed).
	else if (cmd == sysAppLaunchCmdSyncNotify)
		{
//		SyncNotification ();
		}
	

	// P17. The database has been created but there isn't an app info block.
	// Either the HotSync app or another application which uses this application's
	// data may request that the application info block be created by this app
	// (because it's the creator of the database).
	else if (cmd == sysAppLaunchCmdInitDatabase)
		{
		MoneyInitAppInfo (((SysAppLaunchCmdInitDatabaseType*)cmdPBP)->dbP);
		}
	

	return 0;
}
